Package: iSTATS
Type: Package
Title: A Graphical Interface to Perform STOCSY Analyses on NMR Data
Version: 1.7
Date: 2023-12-05
Author: Luiz Henrique Keng Queiroz Junior[aut,cre], Vitor Mendes de Oliveira [aut] 
Maintainer: Luiz Henrique Keng Queiroz Junior <keng@ufg.br>
Description: Launches a 'shiny' based application for Nuclear Magnetic Resonance (NMR)data importation and Statistical TOtal Correlation SpectroscopY (STOCSY) analyses in a full interactive approach. The theoretical background and applications of STOCSY method could be found at Cloarec, O., Dumas, M. E., Craig, A., Barton, R. H., Trygg, J., Hudson, J., Blancher, C., Gauguier, D., Lindon, J. C., Holmes, E. & Nicholson, J. (2005) <doi:10.1021/ac048630x>.
Depends: R(>= 3.6), shinyBS(>= 0.61), shinyWidgets(>= 0.4.3)
Imports: Cairo(>= 1.5), ggplot2(>= 3.0.0), gtools(>= 3.8.1), shiny(>=
        1.0.2), plotly, rstudioapi, data.table, readr
BugReports: https://github.com/vitor-mendes-iq/iSTATS
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.1.1
NeedsCompilation: no
Packaged: 2023-12-05 19:42:54 UTC; sakod
License: GPL (>= 3)
Repository: CRAN
Date/Publication: 2023-12-06 02:10:02 UTC
Built: R 4.6.0; ; 2026-04-30 12:50:39 UTC; unix

# Normalize test
norm_test <- function(p_value,m) {
  p_value <- 0.05
  norm_var <<- c()
  count_norm_y <- 0
  chknorm <- c()
  dif <<- 0

  ## Shapiro normalization test
  for (h in 1:dim(m)[2]) {
    chknorm <- shapiro.test(m[,h])
    if(is.null(chknorm$p.value)) {
      print("merda")
    }

    if (chknorm$p.value <= p_value) {
      norm_var[h] <<- "YES"
    }

    else{
      norm_var[h] <<- "NO"
    }
  }

  ## Count variable normal
  for (k in 1:length(norm_var)) {

    if (norm_var[k]=='YES') {
      count_norm_y <- count_norm_y + 1
    }
  }


  dif <<- round((count_norm_y/length(norm_var))*100,2)

  f <- 0
  g <- 0
  col_sel_norm <<- c()
  col_sel_norm2 <<- c()

  for (j in 1:length(norm_var)) {

    if (norm_var[j] == "NO") {
      f <- f + 1
      col_sel_norm[f] <<- col_select[j]
    }
    else{
      g <- g + 1
      col_sel_norm2[g] <<- col_select[j]
    }
  }
  rr_n$csranges <- CS_values_real[1,col_sel_norm]
  rr_nn$csranges <- CS_values_real[1,col_sel_norm2]

  if (stop_menssager != 1) {

    if (dif <= 70) {
      showModal(modalDialog(
        title = "Warning!!!",
        paste("Your data is ", dif,"% normalized, please apply the apodization
      functions and do a pre-treatment before starting the STOCSY analysis or do not trust R critical "),
        easyClose = FALSE,
        # footer = modalButton("Close"),
        footer = tagList(actionButton("pretreatment", "Normalize Selection"),
                         modalButton("Close")),
        size = "l"
      ))
    }

    else{
      showModal(modalDialog(
        title = "Warning!!!",
        paste("Your data is ", dif,"% normalized."),
        easyClose = FALSE,
        footer = modalButton("Close"),
        size = "l"
      ))
    }

  }
  # return(dif)
  }


###############################################################################

# Calculate of R critical by test t-student table
r_critical <- function(p_value) {

  if(is.null(file_names)){

  }
  else {
  p_value <- p_value
  df <- length(file_names) - 2
  if(p_value != 0) {
  tc <- qt(p_value,df)
  R_CRITICAL <- round(as.numeric(tc/(sqrt(df+tc^2))),3)
  R_CRITICAL <<- c(-abs(R_CRITICAL),abs(R_CRITICAL))
  }}
}
###############################################################################

# Refresh variables
refreshval <- function() {

  #############  PLOT_INTERATIVO_SERVER.R RESET  #############
  peran_multi <- 0
  chkzoom_multi <- 1
  idb_multi <- 0
  testy_multi <<- data.frame(Chemical_Shift=CS_values_real[1,],Spectrum=NMRData[1,])
  ranges_multi$x <<- c(min(CS_values_real[1,]),(max(CS_values_real[1,])))
  ##############################################################################

  #############  SELECT_SIGNALS_SERVER.R RESET  #############
  # NMRData_plot <- NMRData
  NMRData_Mean <- colMeans(NMRData_plot[,])
  spectrums$dat <- data.frame(Chemical_Shift=CS_values_real[1,],Spectrum=(NMRData_Mean[]))
  spectrums_sel$dat <- data.frame(Chemical_Shift=CS_values_real[1,],Spectrum=(NMRData_Mean[]))
  CS_selection$vranges <- c(-13131313,-131313)
  testy <<- data.frame(Chemical_Shift=CS_values_real[1,],Spectrum=NMRData_Mean[])
  col_select <- c()
  alr_click <- 0
  sel_ind <- 0
  peran <- 0
  exran <- c()
  exp_click <- 0
  ysup <- max(testy$Spectrum)
  yinf <- -1000000
  ysup <- ysup + ysup*0.03
  ranges_sel$y <- c(yinf, ysup)
  ranges_sel$x <- c(min(CS_values_real[1,]),(max(CS_values_real[1,])))
  ranges$y <- c(yinf, ysup)
  ranges$x <- c(min(CS_values_real[1,]),(max(CS_values_real[1,])))
  cor_cutoff <- 0.8
  ##############################################################################

  #############  STOCSY_I_SERVER.R RESET  #############
  ncor <-  1
  rr <- c()
  peran_stocsy_i <- 0
  chkzoom_stocsy_i <- 1
  idb_stocsy_i <- 0
  testy_stocsy_i <<- data.frame(Chemical_Shift=CS_values_real[1,])
  ranges_stocsy_i$x <- c(min(CS_values_real[1,]),(max(CS_values_real[1,])))
  facts <<- reactiveValues(fac_stocsy_i = c())
  ##############################################################################

  #############  STOCSY_IS_SERVER.R RESET  #############
  ncor <-  1
  Scaling_cor <- matrix()
  rr_is <- c()
  peran_stocsy_is <- 0
  chkzoom_stocsy_is <- 1
  idb_stocsy_is <- 0
  testy_stocsy_is <<- data.frame(Chemical_Shift=CS_values_real[1,])
  ranges_stocsy_is$x <- c(min(CS_values_real[1,]),(max(CS_values_real[1,])))
  facts_is <<- reactiveValues(fac_stocsy_is = c())
  ##############################################################################

  #############  STOCSY_RT_SERVER.R RESET  #############
  ncor_rt <-  1
  rr_rt <<- c()
  peran_stocsy_rt <- 0
  chkzoom_stocsy_rt <- 1
  idb_stocsy_rt <- 0
  testy_stocsy_rt <<- data.frame(Chemical_Shift=CS_values_real[1,])
  ranges_stocsy_rt$x <- c(min(CS_values_real[1,]),(max(CS_values_real[1,])))
  facts_rt <<- reactiveValues(fac_stocsy_rt = c())
  ##############################################################################

  ###################### Pretreatment_server ###################
  rr_n <<- reactiveValues(csranges = c(-13131313,-131313))
  rr_nn <<- reactiveValues(csranges = c(-13131313,-131313))

  ############################################################


}
####################################################################################

## Module Pré-treatment


###################### Mean centering ##################
.mean_centering <- function() {

  if (!(sel_ind == 0)) {

  # rr_n$csranges <<- c()
  # rr_nn$csranges <- c()


  CS_sel_real <<- CS_selection$vranges[order(CS_selection$vranges,decreasing = TRUE)]
  matr_cor <<- matrix(data = NMRData[,col_select],dim(NMRData)[1], length(CS_sel_real))
  NMR_MC <<- matrix(data = 0, nrow = dim(matr_cor)[1], ncol = dim(matr_cor)[2])
  X_mean <- colMeans(matr_cor)


  for (col in 1:dim(matr_cor)[2]){

    for (lin in 1:dim(matr_cor)[1]){
      NMR_MC[lin,col] <<- matr_cor[lin,col] - X_mean[col]
    }
  }

  norm_test(p_value,m=NMR_MC)
  output$norm_cond <- renderText(paste("Affter normalize: ", dif,"%"))

  # f <- 0
  # g <- 0
  #
  # for (j in 1:length(norm_var)) {
  #
  #   if (norm_var[j] == "NO") {
  #     f <- f + 1
  #     col_sel_norm[f] <<- col_select[j]
  #   }
  #   else{
  #     g <- g + 1
  #     col_sel_norm2[g] <<- col_select[j]
  #   }
  # }
  # rr_n$csranges <- CS_values_real[1,col_sel_norm]
  # rr_nn$csranges <- CS_values_real[1,col_sel_norm2]
  }
  else{
    showModal(modalDialog(
      title = "Warning!!!",
      "No region was selected. You must first select the desired region(s) before to start Normalize section!",
      easyClose = TRUE,
      footer = modalButton("Close"),
      size = "l"
    ))
  }
}
###################### Scaling #########################
.autoscaling <- function() {


  CS_sel_real <<- CS_selection$vranges[order(CS_selection$vranges,decreasing = TRUE)]
  matr_cor <<- matrix(data = NMRData[,col_select],dim(NMRData)[1], length(CS_sel_real))
  NMR_ASC <<- matrix(data = 0, nrow = dim(matr_cor)[1], ncol = dim(matr_cor)[2])
  rows_temp <<- vector(mode="numeric", length=0)
  NMR_MC <<- matrix(data = 0, nrow = dim(matr_cor)[1], ncol = dim(matr_cor)[2])
  X_mean <- colMeans(matr_cor)

  for (col in 1:dim(matr_cor)[2]){

    for (lin in 1:dim(matr_cor)[1]){
      NMR_MC[lin,col] <<- matr_cor[lin,col] - X_mean[col]
    }
  }

  for (col in 1:dim(NMR_MC)[2]){

    for (lin in 1:dim(NMR_MC)[1]) {
      rows_temp[lin] <<- (NMR_MC[lin,col])^2
    }
    sum_MC <- sum(rows_temp)
    sum_MC <- (sum_MC)/(dim(NMR_MC)[1]-1)
    s <- sqrt(sum_MC)

    for (lin in 1:dim(NMR_MC)[1]) {
      NMR_ASC[lin,col] <<- (NMR_MC[lin,col])/(s)
    }
  }

  norm_test(p_value,m=NMR_ASC)

}


##################### Pareto ##########################
.pareto <- function() {

  CS_sel_real <<- CS_selection$vranges[order(CS_selection$vranges,decreasing = TRUE)]
  matr_cor <<- matrix(data = NMRData[,col_select],dim(NMRData)[1], length(CS_sel_real))
  NMR_Pareto <<- matrix(data = 0, nrow = dim(matr_cor)[1], ncol = dim(matr_cor)[2])
  rows_temp <<- vector(mode="numeric", length=0)
  NMR_MC <<- matrix(data = 0, nrow = dim(matr_cor)[1], ncol = dim(matr_cor)[2])
  X_mean <- colMeans(matr_cor)

  for (col in 1:dim(matr_cor)[2]){

    for (lin in 1:dim(matr_cor)[1]){
      NMR_MC[lin,col] <<- matr_cor[lin,col] - X_mean[col]
    }
  }

  for (col in 1:dim(NMR_MC)[2]){

    for (lin in 1:dim(NMR_MC)[1]) {
      rows_temp[lin] <<- (NMR_MC[lin,col])^2
    }
    sum_MC <- sum(rows_temp)
    sum_MC <- (sum_MC)/(dim(NMR_MC)[1]-1)
    s <- sqrt(sum_MC)
    s <- sqrt(s)

    for (lin in 1:dim(NMR_MC)[1]) {
      NMR_Pareto[lin,col] <<- (NMR_MC[lin,col])/(s)
    }
  }

  norm_test(p_value,m=NMR_Pareto)

}


##################### Square root ##########################
.sqr_norm <- function() {

  CS_sel_real <<- CS_selection$vranges[order(CS_selection$vranges,decreasing = TRUE)]
  matr_cor <<- matrix(data = NMRData[,col_select],dim(NMRData)[1], length(CS_sel_real))
  NMR_sqr <<- sqrt(matr_cor)
  norm_test(p_value,m=NMR_sqr)

}


##################### Inverse Square root ##########################
.isqr_norm <- function() {
  CS_sel_real <<- CS_selection$vranges[order(CS_selection$vranges,decreasing = TRUE)]
  matr_cor <<- matrix(data = NMRData[,col_select],dim(NMRData)[1], length(CS_sel_real))
  NMR_i_sqr <<- 1/sqrt(matr_cor)
  norm_test(p_value,m=NMR_i_sqr)

}


##################### Log ##########################
.log_norm <- function() {

  CS_sel_real <<- CS_selection$vranges[order(CS_selection$vranges,decreasing = TRUE)]
  matr_cor <<- matrix(data = NMRData[,col_select],dim(NMRData)[1], length(CS_sel_real))
  NMR_log <<- log(matr_cor)
  norm_test(p_value,m=NMR_log)

}

##################### Start STOCSY-I #################
.s_stocsy <-  function(matr) {
  cor_cutoff_p <<- 0.9
  cor_cutoff_n <<- -0.9

  if (!(sel_ind == 0)) {
    col_select <<- col_select[order(col_select)]
    cor_pearson <<- cor(matr[,])
    drv_pk <<- which.max(matr[1,])
    rr <<- vector(mode="character")
    norm_test(p_value,matr)
    r_critical(p_value)

    updateSliderInput(session, "cutoff_stocsy_i", min = -1,
                      max = 1, value = c(-0.9,0.9) , step= 0.01)


    for (k in 1:dim(NMRData)[2]) {

      if (k %in% col_select) {
        z <<- which(col_select[] == k)


        if (cor_pearson[drv_pk,z] >= cor_cutoff_p) {
          rr[k] <<- "A"
        }

        else {
          rr[k] <<- "B"
        }

        if (cor_pearson[drv_pk,z] <= cor_cutoff_n) {
          rr[k] <<- "C"
        }
      }

      else {
        rr[k] <<- "B"
      }
    }
    facts$fac_stocsy_i <<- rr[]
    facts_is$fac_stocsy_is <<- rr[]
    facts_rt$fac_stocsy_rt <<- rr[]
    updateTabsetPanel(session, "main_bar", "STOCSY-I")
  }

  else {
    showModal(modalDialog(
      title = "Warning!!!",
      "No region was selected. You must first select the desired region(s) before to start STOSCY analysis!",
      easyClose = TRUE,
      footer = modalButton("Close"),
      size = "l"
    ))
  }

}

regions_sel <<-c()
old_sel <<-  0
observeEvent(input$file2, {

  buma <<- 0

  if(is.null(input$file2))  return(NULL)

  up2 <<-input$file2

  if (length(up2$name) < 2) {

    showModal(modalDialog(
      title = "Warning!!!",
      "Please select two or more files before to continue!",
      easyClose = TRUE,
      footer = modalButton("Close"),
      size = "l"
    ))

    buma <<- 1

  }


  else {

    upfile1 <<-list()

    # Upload of samples

    for(l in 1:length(up2$name)) {

      upfile1[[l]] <<- data.table::fread(up2$datapath[l],
                            header = FALSE, sep = ",",data.table=FALSE)

    }


    
    #updateTabsetPanel(session, "main_bar", "Plot Spectra")

  }

})

# regions_selected_input
observeEvent(input$file_regions, {
  data_path_regions <- input$file_regions
  dataset <- read.csv(data_path_regions$datapath, header = FALSE)
  reg_selec_old <<- dataset
  sel_ind <<- 0
  old_sel <<-  1
  
})

# import botton
observeEvent(input$import, {
  
  lslim = as.numeric(input$ls_lims)
  hslim = as.numeric(input$hs_lims)
  
  file_names_full <<- up2$name
  file_names <<- substr(basename(file_names_full),1, nchar(basename(file_names_full))-4)
  file_names_full <<- gtools::mixedsort(file_names_full)
  file_names <<- gtools::mixedsort(file_names)
  list_len <- length(upfile1)
  CS_values <<- unlist((upfile1[[1]][1]),use.names = FALSE, recursive = FALSE)
  NMRData_temp <<- t(lapply(upfile1, function(k) k[,2]))
  hspoint <- which(abs(CS_values-lslim)==min(abs(CS_values-lslim)))[1]
  lspoint <- which(abs(CS_values-hslim)==min(abs(CS_values-hslim)))[1]
  npf = hspoint - lspoint
  np = npf + 1
  CS_values_temp <- lapply(upfile1, function(k) k[,1])
  hspoint <- sapply(CS_values_temp, function (v) which(abs(v-lslim)==min(abs(v-lslim)))[1])
  CS_ind <- which.min(abs(mapply(function(x,y) x[hspoint[y]],CS_values_temp, 1:list_len)))
  CS_values <<- CS_values_temp[[CS_ind]][(hspoint[CS_ind]-npf):hspoint[CS_ind]]
  NMRData <<- t(mapply(function(x,y) x[(hspoint[y]-npf):hspoint[y]],NMRData_temp, 1:list_len))
  CS_values_real <<- rbind(CS_values,CS_values)
  NMRData_plot <<- NMRData
  NMRData <<- NMRData + abs(min(NMRData))
  
  refreshval()
  
  updateSelectInput(session, "spectrum_list_multi", choices = file_names[])
  updateSelectInput(session, "spectrum_list_stocsy_i", choices = file_names[])
  updateSelectInput(session, "spectrum_list_stocsy_is", choices = file_names[])
  updateSelectInput(session, "spectrum_list_stocsy_rt", choices = file_names[])
  updateTabsetPanel(session, "main_bar", "Plot Spectra")
  if(old_sel == 1) {
    reg_selec <<- as.matrix(reg_selec_old)
    pos_map <<- matrix(data = NA,nrow=1,ncol = 2)
    matr_selec <<- matrix(data = NA,dim(NMRData)[1],ncol = 1) 
    for (i in 1:dim(reg_selec)[1]) {
      hlim <- which(abs(CS_values_real[1,]-reg_selec_old[i,1])==min(abs(CS_values_real[1,]-reg_selec_old[i,1])))
      llim <- which(abs(CS_values_real[1,]-reg_selec_old[i,2])==min(abs(CS_values_real[1,]-reg_selec_old[i,2])))
      col_select_old <<- c(col_select_old, seq(llim, hlim, 1))
      pos_low <- which(col_select_old==llim)
      pos_high <- which(col_select_old==hlim)
      pos_map <<- rbind(pos_map, matrix(c(pos_low,pos_high), 1, 2))
      matr_selec <<- cbind(matr_selec,rowSums(matrix(data = NMRData[,llim:hlim],dim(NMRData)[1], length(seq(llim, hlim, 1)))))
      sel_ind <<- sel_ind + 1
    }
    pos_map <<- pos_map[-c(1),]
    matr_selec <<- matr_selec[,-c(1)]
    col_select <<- col_select_old
    CS_selection$vranges <<- CS_values_real[1,col_select]
    old_sel <<- 0
  }
  else{
    col_select_old <<- c()
  }
})

# UI
output$imputa2 <- renderUI({

  tagList(

    (fluidPage(theme = 'zoo.css',

               fluidRow(align = "center",

                        fluidRow(div(style="height:30px")),

                        fileInput("file2", "Choose CSV Files",
                                  multiple = TRUE,
                                  accept = c("text/csv",
                                             "text/comma-separated-values,
                    text/plain",".csv",".CSV")
                        ),

                        # tags$button(id = "import1",
                        #             class = "btn action-button btn_lmax",
                        #             tags$img(src = "csv_i.png",
                        #                      height = "50px", width = "50px")
                        # ),

                        fluidRow(div(style="height:30px")),

                        fluidRow( tags$b("Choose a minimum and a maximum frequency (ppm) for the working spectra:")),

                        fluidRow(div(style="height:15px")),

                        fluidRow(column(5),
                                 column(1, align="center",
                                        textInput("ls_lims", "min","0.0",
                                                  width = "150px")
                                 ),


                                 column(1, align="center",
                                        textInput("hs_lims", "max","10.0", width = "150px")
                                 ),

                                 column(5)

                        ),
                        # import seleted regions
                        fluidRow(align = "center",
                                 
                                 fluidRow(div(style="height:30px")),
                                 
                                 fileInput("file_regions", "Choose your selected regions/areas",
                                           multiple = TRUE,
                                           accept = c("text/csv",
                                                      "text/comma-separated-values,
                                                       text/plain",".csv",".CSV")
                                 )),
                        # start import
                        fluidRow(align = "center",
                                 fluidRow(div(style="height:30px")),
                                 actionButton("import", "import data")
                        ),


                        fluidRow(div(style="height:30px")),

                        fluidRow( tags$b("IMPORTANT: the CSV files must contain only NMR chemical shift and intensity columns, respectively, separated by commas.")),


                        mainPanel(

                        )

               )

    )))

})

# Import and build matrix
observeEvent(input$file1, {
  buma <<- 0
  
  if(is.null(input$file1))  return(NULL)
  up <<-input$file1
  
  if (length(up$name) < 2) {
    showModal(modalDialog(
      title = "Warning!!!",
      "Please select two or more files before to continue!",
      easyClose = TRUE,
      footer = modalButton("Close"),
      size = "l"
    ))
    buma <<- 1
  }
  
  else {
    upfile <<-list()
    
    for(l in 1:length(up$name)) {
      upfile[[l]] <<- data.table::fread(up$datapath[l],
                                        header = FALSE, sep = ",",data.table=FALSE)
    }
    
    lslim = as.numeric(input$ls_lims)
    hslim = as.numeric(input$hs_lims)
    file_names_full <<- up$name
    file_names <<- substr(basename(file_names_full),1, nchar(basename(file_names_full))-4)
    file_names_full <<- gtools::mixedsort(file_names_full)
    file_names <<- gtools::mixedsort(file_names)
    upfile <<- lapply(upfile, function(k) if(anyNA(k)) k[-1,c(4,2)] else k[,c(4,2)])
    list_len <- length(upfile)
    CS_values <<- unlist((upfile[[1]][1]),use.names = FALSE, recursive = FALSE)
    NMRData_temp <<- t(lapply(upfile, function(k) as.numeric(k[,2])))
    hspoint <- which(abs(CS_values-lslim)==min(abs(CS_values-lslim)))[1]
    lspoint <- which(abs(CS_values-hslim)==min(abs(CS_values-hslim)))[1]
    npf = hspoint - lspoint
    np = npf + 1
    CS_values_temp <- lapply(upfile, function(k) k[,1])
    hspoint <- sapply(CS_values_temp, function (v) which(abs(v-lslim)==min(abs(v-lslim)))[1])
    CS_ind <- which.min(abs(mapply(function(x,y) x[hspoint[y]],CS_values_temp, 1:list_len)))
    CS_values <<- CS_values_temp[[CS_ind]][(hspoint[CS_ind]-npf):hspoint[CS_ind]]
    NMRData <<- t(mapply(function(x,y) x[(hspoint[y]-npf):hspoint[y]],NMRData_temp, 1:list_len))
    CS_values_real <<- rbind(CS_values,CS_values)
    NMRData_plot <<- NMRData
    NMRData <<- NMRData + abs(min(NMRData))
    
    refreshval()
    updateSelectInput(session, "spectrum_list_multi", choices = file_names[])
    updateSelectInput(session, "spectrum_list_stocsy_i", choices = file_names[])
    updateSelectInput(session, "spectrum_list_stocsy_is", choices = file_names[])
    updateSelectInput(session, "spectrum_list_stocsy_rt", choices = file_names[])
    updateTabsetPanel(session, "main_bar", "Plot Spectra")
  }
})

# GUI import
output$imputa <- renderUI({
  tagList(
    (fluidPage(theme = 'zoo.css',
               fluidRow(align = "center",
                        fluidRow(div(style="height:30px")),
                        fileInput("file1", "Choose ASC Bruker Files",
                                  multiple = TRUE,
                                  accept = c("text/csv",
                                             "text/comma-separated-values,
                    text/plain",".csv",".CSV")
                        ),
                        fluidRow(div(style="height:30px")),
                        fluidRow( tags$b("Choose a minimum and a maximum frequency (ppm) for the working spectra:")),
                        fluidRow(div(style="height:15px")),
                        fluidRow(column(5),
                                 column(1, align="center",
                                        textInput("ls_lims", "min","0.0",
                                                  width = "150px")
                                 ),
                                 
                                 column(1, align="center",
                                        textInput("hs_lims", "max","10.0", width = "150px")
                                 ),
                                 column(5)
                        ),
                        fluidRow(div(style="height:30px")),
                        fluidRow( tags$b("IMPORTANT: The ASC files should be export by Topspin (Bruker software) using command convbin2asc.")),
                        mainPanel(
                        )
               )
    )))
})

fluidPage(theme = 'zoo.css',
          fluidRow(align = "center",
                   column(2, align="center",

                          sidebarPanel(width = 12,

                          fluidRow(
                            actionButton("mean_norm", "Mean-Centering"),
                            fluidRow(div(style="height:5px")),
                            actionButton("scaling_norm", "Autoscaling"),
                            fluidRow(div(style="height:5px")),
                            actionButton("pareto_norm", "Pareto"),
                            fluidRow(div(style="height:5px")),
                            actionButton("sqr_norm", "Square root"),
                            fluidRow(div(style="height:5px")),
                            actionButton("i_sqr_norm", "Inverse square root"),
                            fluidRow(div(style="height:5px")),
                            actionButton("log_norm", "Log"),
                            fluidRow(div(style="height:5px")),
                            fluidRow(div(style="height:5px"))
                          ),




                        fluidRow(

                          fluidRow(div(style="width:150px;",textInput("pv_n", "p-value", "0.05"))),
                          fluidRow(div(style="width:150px;",verbatimTextOutput("norm_cond"))),
                          fluidRow(
                            tags$button(id = "s_stocsy_i_norm",
                                        class = "btn action-button btn_t",
                                        tags$img(src = "s_stocsy_.png",
                                                 height = "35px", width = "40px")),
                            bsTooltip("s_stocsy_i_norm", "Start STOCSY-I on normalize data",
                                      "right", options = list(container = "body")),


                          ))),

                          sidebarPanel(width = 12,

                          fluidRow(

                          downloadButton("downloadareas2",icon("sakod"),
                                         class = "btn btn-default shiny-download-link",
                                         tags$img(src = "download_buckets.png",
                                                  height = "35px", width = "40px")),
                                          bsTooltip("downloadareas2", "Download selected areas normalized",
                                                    "right", options = list(container = "body"))),
                          fluidRow(div(style="height:5px")),
                          fluidRow(

                          downloadButton("downloadpoints2", icon("sakod"),
                                         class = "btn btn-default shiny-download-link",
                                         tags$img(src = "download_points.png",
                                                  height = "35px", width = "40px")),
                                         bsTooltip("downloadpoints2", "Download selected points normalized",
                                                   "right", options = list(container = "body"))),
                          fluidRow(div(style="height:5px")),
                          fluidRow(

                            tags$button(id = "norm_print_PDF",
                                        class = "btn action-button",
                                        tags$img(src = "exp_stocsy.png",
                                                 height = "35px", width = "40px")),
                            bsTooltip("norm_print_PDF", "Download PDF",
                                      "right", options = list(container = "body")),
                          ))


                   ),


                   column(10, align="center",

                          sidebarPanel(width = 12,

                          fluidRow(
                            fluidRow(p(strong("Non-normal regions will be in red and normal regions in green."))),
                            plotOutput("plot_norm", height = "450px",click = "sel_click", dblclick = "plot_dblclick",
                                       brush = brushOpts(id = "plot_brush_norm",delay = 5000, fill = "#ccc", direction = "xy", resetOnNew = TRUE)
                            )
                          )
                   ))
))

 fluidPage(theme = 'zoo.css',

                  fluidRow(

                    tags$b("If you identify any problem in iSTATS or need some help, please contact us at: keng@ufg.br"
                    ),
                    br(),
                    tags$b("Or in github page"
                    ),
                    tags$a(href="https://github.com/vitor-mendes-iq/iSTATS/issues", "Click here!")


                  )
 )

observeEvent(input$example_but,{

   file_names <<- iSTATS::file_names
   CS_values_real <<- iSTATS::CS_values_real
   NMRData <<- iSTATS::NMRData
   NMRData_plot <<- NMRData
   NMRData <<- NMRData + (abs(min(NMRData))+1)


   refreshval()



   updateSelectInput(session, "spectrum_list_multi", choices = file_names[])

   updateSelectInput(session, "spectrum_list_stocsy_i", choices = file_names[])

   updateSelectInput(session, "spectrum_list_stocsy_is", choices = file_names[])

   updateSelectInput(session, "spectrum_list_stocsy_rt", choices = file_names[])
   #
   # if (NMRData_plot[1,] <= -100 ) {
   #    showModal(modalDialog(
   #       title = "Warning!!!",
   #       "Please apply the apodization functions like FT, ABS and APK and import again",
   #       easyClose = TRUE,
   #       footer = modalButton("Close"),
   #       size = "l"
   #    ))
   # }

   updateTabsetPanel(session, "main_bar", "Plot Spectra")


})

  fluidPage(theme = 'zoo.css',

     sidebarPanel(width = 12,

      fluidRow(div(style="width:300px;",align="center",
      selectInput("spectrum_list_multi","Which spectrum do you want to see?", file_names[], selectize = FALSE)

    )),

      fluidRow(

        tags$button(id = "x2_multi",
                    class = "btn action-button",
                    tags$img(src = "bx2.png",
                             height = "35px", width = "40px")
        ),

        tags$button(id = "x8_multi",
                    class = "btn action-button",
                    tags$img(src = "bx8.png",
                             height = "35px", width = "40px")
        ),

        tags$button(id = "q2_multi",
                    class = "btn action-button",
                    tags$img(src = "bq2.png",
                             height = "35px", width = "40px")
        ),

        tags$button(id = "q8_multi",
                    class = "btn action-button",
                    tags$img(src = "bq8.png",
                             height = "35px", width = "40px")
        ),

        tags$button(id = "all_multi",
                    class = "btn action-button",
                    tags$img(src = "all.png",
                             height = "35px", width = "40px")
        ),

        tags$button(id = "s_left_multi",
                    class = "btn action-button",
                    tags$img(src = "s_left.png",
                             height = "35px", width = "40px")
        ),

        tags$button(id = "s_right_multi",
                    class = "btn action-button",
                    tags$img(src = "s_right.png",
                             height = "35px", width = "40px")
        ),

        tags$button(id = "s_left_f_multi",
                    class = "btn action-button",
                    tags$img(src = "s_left_f.png",
                             height = "35px", width = "40px")
        ),

        tags$button(id = "s_right_f_multi",
                    class = "btn action-button",
                    tags$img(src = "s_right_f.png",
                             height = "35px", width = "40px")
        )

      )
    ),

    sidebarPanel(width = 12,

    fluidRow(align = "center",

      plotly::plotlyOutput("plot_multi")


    ))



  )

(fluidPage(theme = 'zoo.css',

  fluidRow(align = "center",

    fluidRow(div(style="height:30px")),





                    tags$button(
                      id = "choose",
                      class = "btn action-button btn_lmax",
                      tags$img(src = "csv_i.png",
                               height = "50px", width = "50px")
                    ),

                    fluidRow(div(style="height:30px")),

                    fluidRow( tags$b("Choose a minimum and a maximum frequency (ppm) for the working spectra:")),

                    fluidRow(div(style="height:15px")),

                    fluidRow(

                      column(5),

                      column(1, align="center",

                      textInput("ls_lims", "min","0.0", width = "150px")

                    ),


                      column(1, align="center",

                           textInput("hs_lims", "max","10.0", width = "150px")
                           ),

                      column(5)


                    )

                    )

                    ))

  fluidPage(theme = 'zoo.css',

    fluidRow(

      column(12, align="center",

        column(3,align = "left",

          radioButtons("radio_rt", label = h5("Correlation Type"),selected = 1,
                       choices = list("Pearson" = 1, "Spearman" = 2)

          )

        ),

        column(9,align = "center",

        selectInput("spectrum_list_stocsy_rt","Which spectrum do you want to see?",file_names[], selectize = FALSE),

        p(strong("To perform real-time STOCSY analysis, place the cursor on the desired driver peak."))

        )

      )
     ),

      fluidRow(align = "center",

         column(3, align="center",
                sidebarPanel(width =12,

           fluidRow(

              sliderInput("cutoff_stocsy_rt", label = h5("Correlation Cutoff"), min = 0,
                          max = 1, value = 0.9 , step= 0.1)
            ),

            fluidRow(

              tags$button(id = "x2_stocsy_rt",
                          class = "btn action-button",
                          tags$img(src = "bx2.png",
                                   height = "35px", width = "40px")
               ),

              tags$button(id = "x8_stocsy_rt",
                          class = "btn action-button",
                          tags$img(src = "bx8.png",
                                   height = "35px", width = "40px")
                           )
            ),

     fluidRow(div(style="height:5px")),

       fluidRow(

         tags$button(id = "q2_stocsy_rt",
                     class = "btn action-button",
                     tags$img(src = "bq2.png",
                              height = "35px", width = "40px")
          ),

          tags$button(id = "q8_stocsy_rt",
                      class = "btn action-button",
                      tags$img(src = "bq8.png",
                      height = "35px", width = "40px")
                           )
         ),

     br(),

     fluidRow(

       tags$button(id = "s_left_stocsy_rt",
                   class = "btn action-button",
                   tags$img(src = "s_left.png",
                            height = "35px", width = "40px")

        ),

       tags$button(id = "s_right_stocsy_rt",
                   class = "btn action-button",
                   tags$img(src = "s_right.png",
                            height = "35px", width = "40px")
                           )
      ),

     fluidRow(div(style="height:5px")),

     fluidRow(

       tags$button(id = "s_left_f_stocsy_rt",
                   class = "btn action-button",
                   tags$img(src = "s_left_f.png",
                            height = "35px", width = "40px")

        ),

       tags$button(id = "s_right_f_stocsy_rt",
                   class = "btn action-button",
                   tags$img(src = "s_right_f.png",
                            height = "35px", width = "40px"))),


     br(),

     fluidRow(

       tags$button(id = "all_stocsy_rt",
                   class = "btn action-button",
                   tags$img(src = "all.png",
                            height = "35px", width = "40px")

        )

      ),

     br(),
     fluidRow(

       tags$button(id = "stocsy_rt_print_PDF",
                   class = "btn action-button",
                   tags$img(src = "exp_stocsy.png",
                            height = "35px", width = "40px")),
       bsTooltip("stocsy_rt_print_PDF", "Download PDF",
                 "right", options = list(container = "body")),
     )

      )),


      column(9, align="center",

             sidebarPanel(width =12,

         plotOutput("plot_stocsy_rt", width = "100%", height = "500px", click = "click_stocsy_rt", dblclick = "dblclick_stocsy_rt",
                    brush = brushOpts(id = "plot_brush_stocsy_rt",delay = 5000,
                    fill = "#ccc", direction = "xy", resetOnNew = TRUE),hover = hoverOpts(id="hover_stocsy_rt", delay = 750, delayType = "debounce")
          )


      ))
    )
  )

 shinyServer(function(input, output, session) {

   options(shiny.maxRequestSize=100*1024^2)
   source('global.R', local = T)
   source('functions.R', local = T)
   source('uploader_server.R', local = T)
   source('uploader_server_CSV.R', local = T)
   source('uploader_server_Rdata.R', local = T)
   source('plot_interativo_server.R', local = T)
   source('select_signals_server.R', local = T)
   source('Pretreatment_server.R', local = T)
   source('stocsy_i_server.R', local = T)
   source('stocsy_is_server.R', local = T)
   source('stocsy_rt_server.R', local = T)
   source('example_data_server.R', local = T)
})

  ncor_rt <<-  1

  rr_rt <<- c()

  chkzoom_stocsy_rt <<- 1

  idb_stocsy_rt <<- 0

  peran_stocsy_rt <<- 0

  ysup_stocsy_rt <- max(NMRData_plot[1,])

  yinf_stocsy_rt <- ysup_stocsy_rt*-0.03

  ysup_stocsy_rt <- ysup_stocsy_rt + ysup_stocsy_rt*0.03

  testy_stocsy_rt <- data.frame(Chemical_Shift=CS_values_real[1,])

  ranges_stocsy_rt <- reactiveValues(x = c((min(testy_stocsy_rt$Chemical_Shift)), max(testy_stocsy_rt$Chemical_Shift)), y = c(yinf_stocsy_rt,ysup_stocsy_rt))

  spectrums_stocsy_rt <- reactiveValues(dat = data.frame(Chemical_Shift=CS_values_real[1,],Spectrum=NMRData_plot[1,])) #, facs = data.frame(fac_stocsy_rt = rr_rt[])

  facts_rt <<- reactiveValues(fac_stocsy_rt = c())

  #Plot

  output$plot_stocsy_rt <- renderPlot({

    ggplot2::ggplot(spectrums_stocsy_rt$dat,ggplot2::aes(Chemical_Shift,Spectrum)) + ggplot2::geom_line(color='blue') +

    ggplot2::geom_line(ggplot2::aes(colour=facts_rt$fac_stocsy_rt,group=1)) + ggplot2::guides(colour = FALSE) + ggplot2::scale_colour_manual(values = c("red","blue")) +

    ggplot2::coord_cartesian(xlim = c(ranges_stocsy_i$rt[2],ranges_stocsy_i$rt[1]), ylim = ranges_stocsy_rt$y, expand = FALSE) +

    ggplot2::scale_x_reverse() +

      ggplot2::theme(axis.text.x = ggplot2::element_text(size = 12, color = "#000000"),
            axis.text.y = ggplot2::element_text(size = 12, color = "#000000"),
            title = ggplot2::element_text(face = "bold", color = "#000000", size = 17),
            axis.title = ggplot2::element_text(face = "bold", color = "#000000", size = 15)
            ) +

      ggplot2::labs(x = "Chemical Shift", y = "Intensity")

    })


  observeEvent(input$radio_rt, {

    value <<- (input$radio_rt)

    if (value == 1) {

      for (k in 1:dim(NMRData)[2]) {

        if (k %in% col_select) {

            z <<- which(col_select[] == k)



            if (cor_pearson[drv_pk,z] >= cor_cutoff_rt) {

              rr_rt[k] <<- "A"

            }

            else {

              rr_rt[k] <<- "B"


            }
          }

      }

        facts_rt$fac_stocsy_rt <<- rr_rt[]

      }

      if (value == 2) {

        for (k in 1:dim(NMRData)[2]) {

          if (k %in% col_select) {

            z <<- which(col_select[] == k)


            if (cor_spearman[drv_pk,z] >= cor_cutoff_rt) {

              rr_rt[k] <<- "A"

            }

            else {

              rr_rt[k] <<- "B"


            }
          }

         else {

              rr_rt[k] <<- "B"

         }

          }

            facts_rt$fac_stocsy_rt <<- rr_rt[]

          }


      if (value == 3) {

        for (k in 1:dim(NMRData)[2]) {

          if (k %in% col_select) {

            z <<- which(col_select[] == k)

            if (cor_pearson[drv_pk,z] >= cor_cutoff_rt) {

              rr_rt[k] <<- "A"

            }

            else {
            }


              if (cor_spearman[drv_pk,z] >= cor_cutoff_rt) {

              rr_rt[k] <<- "A"

                  }
              else {

              }
            }

           else {
          }
        }


          facts_rt$fac_stocsy_rt <<- rr_rt[]

        }

    })

  observeEvent(input$plot_brush_stocsy_rt,{
    brush <- input$plot_brush_stocsy_rt
    if (!is.null(brush)) {

      ranges_stocsy_rt$x <- c(brush$xmin, brush$xmax)

      ranges_stocsy_rt$y <- c(brush$ymin, brush$ymax)

      idb_stocsy_rt <<- 1

      peran_stocsy_rt <<- (ranges_stocsy_rt$x[2] - ranges_stocsy_rt$x[1])*0.2

      }

    else {

      ranges_stocsy_rt$x <- NULL

    }

  })




  observeEvent(input$x2_stocsy_rt, {

    tryton <<- facts_rt$fac_stocsy_rt

    chkzoom_stocsy_rt <<- chkzoom_stocsy_rt*2


    spectrums_stocsy_rt$dat$Spectrum <- spectrums_stocsy_rt$dat$Spectrum*2

  })


  observeEvent(input$x8_stocsy_rt, {

    chkzoom_stocsy_rt <<- chkzoom_stocsy_rt*8

    spectrums_stocsy_rt$dat$Spectrum <- spectrums_stocsy_rt$dat$Spectrum*8

  })


  observeEvent(input$q2_stocsy_rt, {

    chkzoom_stocsy_rt <<- chkzoom_stocsy_rt/2

    spectrums_stocsy_rt$dat$Spectrum <- spectrums_stocsy_rt$dat$Spectrum/2

  })


  observeEvent(input$q8_stocsy_rt, {

    chkzoom_stocsy_rt <<- chkzoom_stocsy_rt/8

    spectrums_stocsy_rt$dat$Spectrum <- spectrums_stocsy_rt$dat$Spectrum/8

  })


  observeEvent(input$all_stocsy_rt, {

    ranges_stocsy_rt$x <- c((min(testy_stocsy_rt$Chemical_Shift)), max(testy_stocsy_rt$Chemical_Shift))

    freshnum_stocsy_rt <- which(file_names[] == input$spectrum_list_stocsy_rt)

    ysup_stocsy_rt <- max (NMRData_plot[freshnum_stocsy_rt,])

    yinf_stocsy_rt <- ysup_stocsy_rt*-0.03

    ysup_stocsy_rt <- ysup_stocsy_rt + ysup_stocsy_rt*0.03

    ranges_stocsy_rt$y <- c(yinf_stocsy_rt,ysup_stocsy_rt)

    spectrums_stocsy_rt$dat$Spectrum <- spectrums_stocsy_rt$dat$Spectrum/chkzoom_stocsy_rt

    chkzoom_stocsy_rt <<- 1

    idb_stocsy_rt <<- 0

  })

  observeEvent(input$s_left_stocsy_rt, {

    if (!(ranges_stocsy_rt$x[1] <= min(testy_stocsy_rt$Chemical_Shift))) {

      ranges_stocsy_rt$x[1] <<- (ranges_stocsy_rt$x[1] - peran_stocsy_rt)

      ranges_stocsy_rt$x[2] <<- (ranges_stocsy_rt$x[2] - peran_stocsy_rt)

     }

  })

  observeEvent(input$s_right_stocsy_rt, {

    if (!(ranges_stocsy_rt$x[2] >= max(testy_stocsy_rt$Chemical_Shift))) {

      ranges_stocsy_rt$x[1] <<- (ranges_stocsy_rt$x[1] + peran_stocsy_rt)

      ranges_stocsy_rt$x[2] <<- (ranges_stocsy_rt$x[2] + peran_stocsy_rt)

      }

  })

  observeEvent(input$s_left_f_stocsy_rt, {

    if (!(ranges_stocsy_rt$x[1] <= min(testy_stocsy_rt$Chemical_Shift))) {

      das_stocsy_rt <<- (ranges_stocsy_rt$x[2] - ranges_stocsy_rt$x[1])

      ranges_stocsy_rt$x[1] <<- min(testy_stocsy_rt$Chemical_Shift)

      ranges_stocsy_rt$x[2] <<- (min(testy_stocsy_rt$Chemical_Shift) + das_stocsy_rt)

      }

  })

  observeEvent(input$s_right_f_stocsy_rt, {

    if (!(ranges_stocsy_rt$x[2] >= max(testy_stocsy_rt$Chemical_Shift))) {

        das_stocsy_rt <<- (ranges_stocsy_rt$x[2] - ranges_stocsy_rt$x[1])

        ranges_stocsy_rt$x[2] <<- max(testy_stocsy_rt$Chemical_Shift)

        ranges_stocsy_rt$x[1] <<- (max(testy_stocsy_rt$Chemical_Shift) - das_stocsy_rt)

      }

  })


  observeEvent(input$spectrum_list_stocsy_rt,{

    freshnum_stocsy_rt <- which(file_names[] == input$spectrum_list_stocsy_rt)

    spectrums_stocsy_rt$dat <- data.frame(Chemical_Shift=CS_values_real[1,],Spectrum=NMRData_plot[freshnum_stocsy_rt,])

    if (!idb_stocsy_rt && chkzoom_stocsy_rt == 1) {

      ysup_stocsy_rt <- max (NMRData_plot[freshnum_stocsy_rt,])

      yinf_stocsy_rt <- ysup_stocsy_rt*-0.03

      ysup_stocsy_rt <- ysup_stocsy_rt + ysup_stocsy_rt*0.03

      ranges_stocsy_rt$y <- c(yinf_stocsy_rt, ysup_stocsy_rt)

     }

    else {

        spectrums_stocsy_rt$dat$Spectrum <- spectrums_stocsy_rt$dat$Spectrum*chkzoom_stocsy_rt

      }

    })

  observeEvent(input$dblclick_stocsy_rt, {

    drv_pk_ort <<- which(abs(CS_values_real[1,]-input$dblclick_stocsy_rt$x)==min(abs(CS_values_real[1,]-input$dblclick_stocsy_rt$x)))

    if (drv_pk %in% col_select) {

    drv_pk <<- which(col_select[] == drv_pk)

      for (k in 1:dim(NMRData)[2]) {

        if (k %in% col_select) {

          z <<- which(col_select[] == k)

          if (cor_pearson[drv_pk,z] >= input$cutoff_stocsy_rt) {

            rr_rt[k] <<- "A"

          }

          else {

            rr_rt[k] <<- "B"

          }

        }

        else {

          rr_rt[k] <<- "B"  #falta transformar 'rr_rt' em variavel reativa

        }

        }

        facts_rt$fac_stocsy_rt <<- rr_rt[]

      }

      else {

        showModal(modalDialog(
          title = "Warning!!!",
          "The selected point is not inside the previously loaded regions. Please, click on another point or load a new group of signals!",
          easyClose = TRUE,
          footer = modalButton("Close"),
          size = "l",

          drv_pk <- drv_pk_ort



          )
        )

      }

    })


    observeEvent(input$cutoff_stocsy_rt, {

      cor_cutoff_rt <<- input$cutoff_stocsy_rt

      for (k in 1:dim(NMRData)[2]) {

        if (k %in% col_select) {

          z <<- which(col_select[] == k)

          if (cor_pearson[drv_pk,z] >= cor_cutoff_rt) {

            rr_rt[k] <<- "A"

          }

          else {

            rr_rt[k] <<- "B"

          }

        }

        else {

          rr_rt[k] <<- "B"  #falta transformar 'rr_rt' em variavel reativa

        }

      }

      facts_rt$fac_stocsy_rt <<- rr_rt[]


       })

    # Plot_PDF I-STOCSY
    observeEvent(input$stocsy_rt_print_PDF, {
      ggplot2::ggsave("stocsy-rt.pdf",path = choose.dir(),width=195, height=105, units="mm", dpi = 300)
    })


  observeEvent(input$hover_stocsy_rt, {

    drv_pk <<- which(abs(CS_values_real[1,]-input$hover_stocsy_rt$x)==min(abs(CS_values_real[1,]-input$hover_stocsy_rt$x)))

    if (drv_pk %in% col_select) {

      drv_pk <<- which(col_select[] == drv_pk)

      for (k in 1:dim(NMRData)[2]) {

        if (k %in% col_select) {

          z <<- which(col_select[] == k)

          if (cor_pearson[drv_pk,z] >= 0.8) {

             rr_rt[k] <<- "A"

            }

           else {

                rr_rt[k] <<- "B"

              }

            }

          else {

              rr_rt[k] <<- "B"  #falta transformar 'rr_rt' em variavel reativa

            }

      }

        facts_rt$fac_stocsy_rt <<- rr_rt[]

      }

        else {

        }

    })

dc <- c()
file_names <- c()
NMRData <- matrix(0, 2,2)
CS_values_real <- matrix(0, 2,2)
R_CRITICAL <<- 0.8
matr_cor <- matrix(seq(1,10,1), 10,10)
NMRData_plot <- matrix(seq(1,10,1), 10,10)
p_value <<- 0.05
choose_norm <<- 1
stop_menssager <<- 0

# não esquecer de voltar matr_cor
onStop(function() {

  message("Stopping iSTATS ...\n")

  clear_list <- c("stop_menssager","n_dpi","rr_nn","norm_var","col_sel_norm2","yinf","NMRData_plot","peran","rows_temp","p_value","choose_norm","testy_norm","NMR_sqr",
                  "NMR_Pareto","NMR_MC","NMR_log","NMR_i_sqr","NMR_ASC","matr_cor","s_stoc","rr2",
                  "rowns_temp","dif","cor_cutoff_value_p","cor_cutoff_value_n","col_sel_norm",
                  "test_norm","R_CRITICAL","rr_n","CS_norm","CS_selection","gg","gr","buma","CS_values_real",
                  "NMRData","NMRData_temp", "facts","facts_is","facts_rt","Scaling_cor", "up2", "up","up3",
                  "testy","testy_multi","testy_stocsy_i","alr_click","upfile3",
                  "chkzoom","chkzoom_multi","chkzoom_stocsy_i","chkzoom_stocsy_is",
                  "chkzoom_stocsy_rt", "col_select","cor_cutoff","cor_cutoff_i",
                  "cor_cutoff_rt","dc","exp_click","exran","file_names","idb",
                  "idb_multi","idb_stocsy_i","idb_stocsy_is","idb_stocsy_rt",
                  "ncor","ncor_rt","ndpi","ndpis","peran_multi","peran_stocsy_i",
                  "peran_stocsy_is","peran_stocsy_rt","rr","rr_is","rr_rt","sel_ind",
                  "value","cor_pearson","cor_spearman","matr_selec",
                  "pos_map","reg_selec","up","col_select_2","CS_sel_real",
                  "CS_values","drv_pk","file_names_full","file_names_full",
                  "peran_sel","s_ind","z","das_multi","das_stocsy_i","das_stocsy_is",
                  "das_stocsy_rt","drv_pk_ois","drv_pk_oi","drv_pk_ort","s","tryton")

suppressWarnings(
  suppressMessages({
    garb <- try(sapply(clear_list, function(x) if (exists(x, envir = .GlobalEnv)) rm(list = x, envir = .GlobalEnv)), silent = TRUE)
    rm(garb)
  })
)

stopApp()

})

  #Variables
  ndpi <<- 72
  ncor <<-  1
  rr <<- c()
  rr2 <<- c()
  chkzoom_stocsy_i <<- 1
  idb_stocsy_i <<- 0
  peran_stocsy_i <<- 0
  ysup_stocsy_i <- max(NMRData_plot[1,])
  yinf_stocsy_i <- ysup_stocsy_i*-0.03
  ysup_stocsy_i <- ysup_stocsy_i + ysup_stocsy_i*0.03
  R_CRITICAL_n <- 0

  # Dataframe
  testy_stocsy_i <<- data.frame(Chemical_Shift=CS_values_real[1,])
  ranges_stocsy_i <- reactiveValues(x = c((min(testy_stocsy_i$Chemical_Shift)), max(testy_stocsy_i$Chemical_Shift)), y = c(yinf_stocsy_i,ysup_stocsy_i))
  spectrums_stocsy_i <- reactiveValues(dat = data.frame(Chemical_Shift=CS_values_real[1,],Spectrum=NMRData_plot[1,])) #, facs = data.frame(fac_stocsy_i = rr[])
  facts <<- reactiveValues(fac_stocsy_i = c())

  #Plot
  output$plot_stocsy_i <- renderPlot({
    ggplot2::ggplot(spectrums_stocsy_i$dat,ggplot2::aes(Chemical_Shift,Spectrum)) + ggplot2::geom_line(color='blue') +
      ggplot2::geom_line(ggplot2::aes(colour=facts$fac_stocsy_i, group=1)) + ggplot2::scale_colour_manual(values =c("red","blue","green")) +
      ggplot2::coord_cartesian(xlim = c(ranges_stocsy_i$x[2],ranges_stocsy_i$x[1]), ylim = ranges_stocsy_i$y, expand = FALSE) +
      ggplot2::scale_x_reverse() +
      ggplot2::theme(axis.text.x = ggplot2::element_text(size = 12, color = "#000000"),
                     axis.text.y = ggplot2::element_text(size = 12, color = "#000000"),
                     title = ggplot2::element_text(face = "bold", color = "#000000", size = 17),
                     axis.title = ggplot2::element_text(face = "bold", color = "#000000", size = 15),
                     legend.position="none"
      ) +
      ggplot2::labs(x = "Chemical Shift", y = "Intensity")
    })

  # Brush Zoom
  observeEvent(input$plot_brush_stocsy_i,{
    brush <- input$plot_brush_stocsy_i

    if (!is.null(brush)) {
      ranges_stocsy_i$x <- c(brush$xmin, brush$xmax)
      ranges_stocsy_i$y <- c(brush$ymin, brush$ymax)
      idb_stocsy_i <<- 1
      peran_stocsy_i <<- (ranges_stocsy_i$x[2] - ranges_stocsy_i$x[1])*0.2
      }

      else {
        ranges_stocsy_i$x <- NULL
      }
    })


  # Intensity x2
  observeEvent(input$x2_stocsy_i, {
    tryton <<- facts$fac_stocsy_i
    chkzoom_stocsy_i <<- chkzoom_stocsy_i*2
    spectrums_stocsy_i$dat$Spectrum <- spectrums_stocsy_i$dat$Spectrum*2
  })


  # Intensity x8
  observeEvent(input$x8_stocsy_i, {
    chkzoom_stocsy_i <<- chkzoom_stocsy_i*8
    spectrums_stocsy_i$dat$Spectrum <- spectrums_stocsy_i$dat$Spectrum*8
  })


  # Intensity /2
  observeEvent(input$q2_stocsy_i, {
    chkzoom_stocsy_i <<- chkzoom_stocsy_i/2
    spectrums_stocsy_i$dat$Spectrum <- spectrums_stocsy_i$dat$Spectrum/2
  })


  # Intensity /8
  observeEvent(input$q8_stocsy_i, {
    chkzoom_stocsy_i <<- chkzoom_stocsy_i/8
    spectrums_stocsy_i$dat$Spectrum <- spectrums_stocsy_i$dat$Spectrum/8
  })


  # Show all
  observeEvent(input$all_stocsy_i, {
    ranges_stocsy_i$x <- c((min(testy_stocsy_i$Chemical_Shift)), max(testy_stocsy_i$Chemical_Shift))
    freshnum_stocsy_i <- which(file_names[] == input$spectrum_list_stocsy_i)
    ysup_stocsy_i <- max (NMRData_plot[freshnum_stocsy_i,])
    yinf_stocsy_i <- ysup_stocsy_i*-0.03
    ysup_stocsy_i <- ysup_stocsy_i + ysup_stocsy_i*0.03
    ranges_stocsy_i$y <- c(yinf_stocsy_i,ysup_stocsy_i)
    spectrums_stocsy_i$dat$Spectrum <- spectrums_stocsy_i$dat$Spectrum/chkzoom_stocsy_i
    chkzoom_stocsy_i <<- 1
    idb_stocsy_i <<- 0
  })


  # Move left
  observeEvent(input$s_left_stocsy_i, {
    if (!(ranges_stocsy_i$x[1] <= min(testy_stocsy_i$Chemical_Shift))) {
    ranges_stocsy_i$x[1] <<- (ranges_stocsy_i$x[1] - peran_stocsy_i)
    ranges_stocsy_i$x[2] <<- (ranges_stocsy_i$x[2] - peran_stocsy_i)
    }
  })


  # Move right
  observeEvent(input$s_right_stocsy_i, {
    if (!(ranges_stocsy_i$x[2] >= max(testy_stocsy_i$Chemical_Shift))) {
    ranges_stocsy_i$x[1] <<- (ranges_stocsy_i$x[1] + peran_stocsy_i)
    ranges_stocsy_i$x[2] <<- (ranges_stocsy_i$x[2] + peran_stocsy_i)
    }
  })


  # Move full left
  observeEvent(input$s_left_f_stocsy_i, {
    if (!(ranges_stocsy_i$x[1] <= min(testy_stocsy_i$Chemical_Shift))) {
    das_stocsy_i <<- (ranges_stocsy_i$x[2] - ranges_stocsy_i$x[1])
    ranges_stocsy_i$x[1] <<- min(testy_stocsy_i$Chemical_Shift)
    ranges_stocsy_i$x[2] <<- (min(testy_stocsy_i$Chemical_Shift) + das_stocsy_i)
    }
  })


  # Move full right
  observeEvent(input$s_right_f_stocsy_i, {
    if (!(ranges_stocsy_i$x[2] >= max(testy_stocsy_i$Chemical_Shift))) {
      das_stocsy_i <<- (ranges_stocsy_i$x[2] - ranges_stocsy_i$x[1])
      ranges_stocsy_i$x[2] <<- max(testy_stocsy_i$Chemical_Shift)
      ranges_stocsy_i$x[1] <<- (max(testy_stocsy_i$Chemical_Shift) - das_stocsy_i)
    }
  })


  ## Download plot


  # DPI
  observeEvent(input$slide_dpi, {

    n_dpi <<- input$slide_dpi

  })

  # Botton download plot
  output$plot_download <- downloadHandler(
    filename = function() {
      paste0('stocsy-i.',input$data_input)
    },
    content = function(file1) {
      ggplot2::ggsave(file1,width=295, device = input$data_input,height=205, units="mm", dpi = n_dpi)

    }
  )


  # List of samples for plot
  observeEvent(input$spectrum_list_stocsy_i,{
    freshnum_stocsy_i <- which(file_names[] == input$spectrum_list_stocsy_i)
    spectrums_stocsy_i$dat <- data.frame(Chemical_Shift=CS_values_real[1,],Spectrum=NMRData_plot[freshnum_stocsy_i,])

    if (!idb_stocsy_i && chkzoom_stocsy_i == 1) {
    ysup_stocsy_i <- max (NMRData_plot[freshnum_stocsy_i,])
    yinf_stocsy_i <- ysup_stocsy_i*-0.03
    ysup_stocsy_i <- ysup_stocsy_i + ysup_stocsy_i*0.03
    ranges_stocsy_i$y <- c(yinf_stocsy_i, ysup_stocsy_i)
    }

    else {
        spectrums_stocsy_i$dat$Spectrum <- spectrums_stocsy_i$dat$Spectrum*chkzoom_stocsy_i
    }
  })


  # Slide bar cor-cutoff
  observeEvent(input$cutoff_stocsy_i, {
    cor_cutoff_i <<- input$cutoff_stocsy_i

    for (g in 1:length(cor_cutoff_i)) {

       if (cor_cutoff_i[g] > 0) {
        cor_cutoff_value_p <<- cor_cutoff_i[g]   #positive values
      }

      else {
        cor_cutoff_value_n <<- cor_cutoff_i[g]     #negative values
      }
    }

    for (k in 1:dim(NMRData)[2]) {

      if (k %in% col_select) {
        z <<- which(col_select[] == k)

        if (cor_pearson[drv_pk,z] >= cor_cutoff_value_p) {
          rr[k] <<- "A"
        }

        else {
          rr[k] <<- "B"
        }

        if (cor_pearson[drv_pk,z] <= cor_cutoff_value_n) {
          rr[k] <<- "C"
        }}

      else {
        rr[k] <<- "B"  #falta transformar 'rr' em variavel reativa
      }
    }
    facts$fac_stocsy_i <<- rr[]
  })


  # Radio Button choose type correlation.
  observeEvent(input$radio, {
    value <<- (input$radio)

    # Pearson
    if (value == 1){

      for (k in 1:dim(NMRData)[2]) {

        if (k %in% col_select) {
          z <<- which(col_select[] == k)

          if (cor_pearson[drv_pk,z] >= cor_cutoff_value_p) {
            rr[k] <<- "A"
          }

          else {
            rr[k] <<- "B"
          }

          if (cor_pearson[drv_pk,z] <= cor_cutoff_value_n) {
            rr[k] <<- "C"
          }}

        else {
          rr[k] <<- "B"  #falta transformar 'rr' em variavel reativa
        }
      }
      facts$fac_stocsy_i <<- rr[]
    }

    # Spearman
    if (value == 2) {

      for (k in 1:dim(NMRData)[2]) {

        if (k %in% col_select) {
          z <<- which(col_select[] == k)

          if (cor_spearman[drv_pk,z] >= cor_cutoff_value_p) {
            rr[k] <<- "A"
          }

          else {
            rr[k] <<- "B"
          }

          if (cor_spearman[drv_pk,z] <= cor_cutoff_value_n) {
            rr[k] <<- "C"
          }
        }

        else {
          rr[k] <<- "B"  #falta transformar 'rr' em variavel reativa
        }
      }
      facts$fac_stocsy_i <<- rr[]
    }

    # PearSpear
    if (value == 3) {

      for (k in 1:dim(NMRData)[2]) {

        if (k %in% col_select) {
          z <<- which(col_select[] == k)

          if (cor_pearson[drv_pk,z] >= cor_cutoff_value_p) {
            rr[k] <<- "A"
          }

          else {
            rr[k] <<- "B"
          }

          if (cor_pearson[drv_pk,z] <= cor_cutoff_value_n) {
            rr[k] <<- "C"
          }
        }

        else {
          rr[k] <<- "B"  #falta transformar 'rr' em variavel reativa
        }

          if (cor_spearman[drv_pk,z] >= cor_cutoff_value_p) {
            rr[k] <<- "A"
          }

          else {
            rr[k] <<- "B"
          }

          if (cor_spearman[drv_pk,z] <= cor_cutoff_value_n) {
            rr[k] <<- "C"
          }

        else {
          rr[k] <<- "B"  #falta transformar 'rr' em variavel reativa
        }
      }
      facts$fac_stocsy_i <<- rr[]
      }
  })


  # R critical by P-value
  observeEvent(input$pv, {
    p_value_n <- as.numeric(input$pv)
    r_critical(p_value_n)
    output$r_critical <- renderText(paste("R critical = +/-",abs(R_CRITICAL[1])))
  })


  # Drive peak
  observeEvent(input$dblclick_stocsy_i, {
    drv_pk_oi <<- which(abs(CS_values_real[1,]-input$dblclick_stocsy_i$x)==min(abs(CS_values_real[1,]-input$dblclick_stocsy_i$x)))

    if (drv_pk_oi %in% col_select) {
      drv_pk <<- which(col_select[] == drv_pk_oi)

      for (k in 1:dim(NMRData)[2]) {

        if (k %in% col_select) {
          z <<- which(col_select[] == k)

          if (cor_pearson[drv_pk,z] >= cor_cutoff_value_p) {
            rr[k] <<- "A"
          }

          else {
            rr[k] <<- "B"
          }

          if (cor_pearson[drv_pk,z] <= cor_cutoff_value_n){
            rr[k] <<- "C"
          }

        }

        else {
          rr[k] <<- "B"  #falta transformar 'rr' em variavel reativa
        }

        }
        facts$fac_stocsy_i <<- rr[]
      }

      else {
        showModal(modalDialog(
          title = "Warning!!!",
          "The selected point is not inside the previously loaded regions. Please, click on another point or load a new group of signals!",
          easyClose = TRUE,
          footer = modalButton("Close"),
          size = "l",
          drv_pk <- drv_pk_oi
        ))
      }
  })

  ndpis <<- 72

  ncor <<-  1

  Scaling_cor <<- matrix()

  rr_is <<- c()

  peran_stocsy_is <<- 0

  chkzoom_stocsy_is <<- 1

  idb_stocsy_is <<- 0


  ysup_stocsy_is <- max(NMRData_plot[1,])

  yinf_stocsy_is <- ysup_stocsy_is*-0.03

  ysup_stocsy_is <- ysup_stocsy_is + ysup_stocsy_is*0.03


  testy_stocsy_is <- data.frame(Chemical_Shift=CS_values_real[1,])

  ranges_stocsy_is <- reactiveValues(x = c((min(testy_stocsy_is$Chemical_Shift)), max(testy_stocsy_is$Chemical_Shift)), y = c(yinf_stocsy_is,ysup_stocsy_is))

  normalize <- (NMRData[1,] - min(NMRData[1,]))

  spectrums_stocsy_is <- reactiveValues(dat = data.frame(Chemical_Shift=CS_values_real[1,],Spectrum=NMRData_plot[1,])) #, facs = data.frame(fac_stocsy_is = rr_is[])

  facts_is <<- reactiveValues(fac_stocsy_is = c())

  output$plot_stocsy_is <- renderPlot({

    ggplot2::ggplot(spectrums_stocsy_is$dat,ggplot2::aes(Chemical_Shift,Spectrum)) + ggplot2::geom_line(color='blue') +

      ggplot2::geom_line(ggplot2::aes(colour=facts_is$fac_stocsy_is,group=1)) + ggplot2::guides(colour = FALSE) + ggplot2::scale_colour_manual(values = c("red","blue")) +

      ggplot2::coord_cartesian(xlim = c(ranges_stocsy_is$x[2],ranges_stocsy_is$x[1]), ylim = ranges_stocsy_is$y, expand = FALSE) +

      ggplot2::scale_x_reverse() +

      ggplot2::theme(axis.text.x = ggplot2::element_text(size = 12, color = "#000000"),
                     axis.text.y = ggplot2::element_text(size = 12, color = "#000000"),
                     title = ggplot2::element_text(face = "bold", color = "#000000", size = 17),
                     axis.title = ggplot2::element_text(face = "bold", color = "#000000", size = 15)
       ) +

    ggplot2::labs(x = "Chemical Shift", y = "Intensity")

})


  observeEvent(input$stocsy_s, {

    for (k in 1:dim(cor_pearson)[2]) {

      Scaling_cor <<- (1 - (cor_pearson[drv_pk,k]*cor_pearson[drv_pk,k]))

      s <<- col_select[k]

      if(drv_pk != k) {

        spectrums_stocsy_is$dat$Spectrum[s] <<- spectrums_stocsy_is$dat$Spectrum[s]*Scaling_cor

      }

      else {

        spectrums_stocsy_is$dat$Spectrum[s] <<- spectrums_stocsy_is$dat$Spectrum[s]*0.02

      }
    }

  })


  observeEvent(input$radio_is, {

    value <<- (input$radio_is)

    if (value == 1) {

      for (k in 1:dim(NMRData)[2]) {

        if (k %in% col_select) {

          z <<- which(col_select[] == k)



          if (cor_pearson[drv_pk,z] >= cor_cutoff) {

            rr_is[k] <<- "A"

          }

          else {

            rr_is[k] <<- "B"

          }

        }

      }

      facts_is$fac_stocsy_is <<- rr_is[]

    }

    if (value == 2) {

      for (k in 1:dim(NMRData)[2]) {

      if (k %in% col_select) {

        z <<- which(col_select[] == k)


        if (cor_spearman[drv_pk,z] >= cor_cutoff) {

          rr_is[k] <<- "A"

        }

        else {

          rr_is[k] <<- "B"

        }}

    else {

        rr_is[k] <<- "B"  #falta transformar 'rr_is' em variavel reativa

    }
    }

    facts_is$fac_stocsy_is <<- rr_is[]

    }


  if (value == 3) {

    for (k in 1:dim(NMRData)[2]) {

      if (k %in% col_select) {

        z <<- which(col_select[] == k)

        if (cor_pearson[drv_pk,z] >= cor_cutoff) {

          rr_is[k] <<- "A"

        }

        else {  }


        if (cor_spearman[drv_pk,z] >= cor_cutoff) {

          rr_is[k] <<- "A"

        }
        else {

        }
        }

      else {  }

    }


    facts_is$fac_stocsy_is <<- rr_is[]

    }

  })

  observeEvent(input$plot_brush_stocsy_is,{
    brush <- input$plot_brush_stocsy_is
    if (!is.null(brush)) {

      ranges_stocsy_is$x <- c(brush$xmin, brush$xmax)

      ranges_stocsy_is$y <- c(brush$ymin, brush$ymax)

      idb_stocsy_is <<- 1

      peran_stocsy_is <<- (ranges_stocsy_is$x[2] - ranges_stocsy_is$x[1])*0.2



    }

    else {

      ranges_stocsy_is$x <- NULL

    }
  })

  observeEvent(input$x2_stocsy_is, {

    tryton <<- facts_is$fac_stocsy_is

    chkzoom_stocsy_is <<- chkzoom_stocsy_is*2

    spectrums_stocsy_is$dat$Spectrum <- spectrums_stocsy_is$dat$Spectrum*2

  })


  observeEvent(input$x8_stocsy_is, {

    chkzoom_stocsy_is <<- chkzoom_stocsy_is*8

    spectrums_stocsy_is$dat$Spectrum <- spectrums_stocsy_is$dat$Spectrum*8

  })


  observeEvent(input$q2_stocsy_is, {

    chkzoom_stocsy_is <<- chkzoom_stocsy_is/2

    spectrums_stocsy_is$dat$Spectrum <- spectrums_stocsy_is$dat$Spectrum/2

  })


  observeEvent(input$q8_stocsy_is, {

    chkzoom_stocsy_is <<- chkzoom_stocsy_is/8

    spectrums_stocsy_is$dat$Spectrum <- spectrums_stocsy_is$dat$Spectrum/8

  })


  observeEvent(input$all_stocsy_is, {

    ranges_stocsy_is$x <- c(min(CS_values_real[1,]),(max(CS_values_real[1,])))

    freshnum_stocsy_is <- which(file_names[] == input$spectrum_list_stocsy_is)

    ysup_stocsy_is <- max (NMRData_plot[freshnum_stocsy_is,])

    yinf_stocsy_is <- ysup_stocsy_is*-0.03

    ysup_stocsy_is <- ysup_stocsy_is + ysup_stocsy_is*0.03

    ranges_stocsy_is$y <- c(yinf_stocsy_is,ysup_stocsy_is)

    spectrums_stocsy_is$dat$Spectrum <- spectrums_stocsy_is$dat$Spectrum/chkzoom_stocsy_is

    chkzoom_stocsy_is <<- 1

    idb_stocsy_is <<- 0

  })


  observeEvent(input$s_left_stocsy_is, {

    if (!(ranges_stocsy_is$x[1] <= min(testy_stocsy_is$Chemical_Shift))) {

      ranges_stocsy_is$x[1] <<- (ranges_stocsy_is$x[1] - peran_stocsy_is)

      ranges_stocsy_is$x[2] <<- (ranges_stocsy_is$x[2] - peran_stocsy_is)

    }

  })


  observeEvent(input$s_right_stocsy_is, {

    if (!(ranges_stocsy_is$x[2] >= max(testy_stocsy_is$Chemical_Shift))) {

      ranges_stocsy_is$x[1] <<- (ranges_stocsy_is$x[1] + peran_stocsy_is)

      ranges_stocsy_is$x[2] <<- (ranges_stocsy_is$x[2] + peran_stocsy_is)

    }

  })


  observeEvent(input$s_left_f_stocsy_is, {

    if (!(ranges_stocsy_is$x[1] <= min(testy_stocsy_is$Chemical_Shift))) {

      das_stocsy_is <<- (ranges_stocsy_is$x[2] - ranges_stocsy_is$x[1])

      ranges_stocsy_is$x[1] <<- min(testy_stocsy_is$Chemical_Shift)

      ranges_stocsy_is$x[2] <<- (min(testy_stocsy_is$Chemical_Shift) + das_stocsy_is)

    }

  })


  observeEvent(input$s_right_f_stocsy_is, {

    if (!(ranges_stocsy_is$x[2] >= max(testy_stocsy_is$Chemical_Shift))) {

      das_stocsy_is <<- (ranges_stocsy_is$x[2] - ranges_stocsy_is$x[1])

      ranges_stocsy_is$x[2] <<- max(testy_stocsy_is$Chemical_Shift)

      ranges_stocsy_is$x[1] <<- (max(testy_stocsy_is$Chemical_Shift) - das_stocsy_is)

    }

  })


  observeEvent(input$spectrum_list_stocsy_is,{

    freshnum_stocsy_is <- which(file_names[] == input$spectrum_list_stocsy_is)

    normalize <<- (NMRData_plot[freshnum_stocsy_is,] - min(NMRData_plot[freshnum_stocsy_is,]))

    spectrums_stocsy_is$dat <- data.frame(Chemical_Shift=CS_values_real[1,],Spectrum=normalize)


    if (!idb_stocsy_is && chkzoom_stocsy_is == 1) {

      ysup_stocsy_is <- max (normalize[])

      yinf_stocsy_is <- ysup_stocsy_is*-0.03

      ysup_stocsy_is <- ysup_stocsy_is + ysup_stocsy_is*0.03

      ranges_stocsy_is$y <- c(yinf_stocsy_is, ysup_stocsy_is)

    }

    else {

      spectrums_stocsy_is$dat$Spectrum_ <- spectrums_stocsy_is$dat$Spectrum*chkzoom_stocsy_is

    }

  })

  observeEvent(input$dblclick_stocsy_is, {

    drv_pk_ois <<- which(abs(CS_values_real[1,]-input$dblclick_stocsy_is$x)==min(abs(CS_values_real[1,]-input$dblclick_stocsy_is$x)))

      if (drv_pk_ois %in% col_select) {

        drv_pk <<- which(col_select[] == drv_pk_ois)

        for (k in 1:dim(NMRData)[2]) {

          if (k %in% col_select) {

          z <<- which(col_select[] == k)

            if (cor_pearson[drv_pk,z] >= input$cutoff_stocsy_is) {

            rr_is[k] <<- "A"

            }

            else {

              rr_is[k] <<- "B"

            }

          }

          else {

            rr_is[k] <<- "B"

          }

    }

      facts_is$fac_stocsy_is <<- rr_is[]

    }

    else {

    showModal(modalDialog(
      title = "Warning!!!",
      "The selected point is not inside the previously loaded regions. Please, click on another point or load a new group of signals!",
      easyClose = TRUE,
      footer = modalButton("Close"),
      size = "l",

      drv_pk <- drv_pk_ois


    ))

    }

  })



  ## Download plot


  # DPI
  observeEvent(input$slide_dpi_is, {

    n_dpi <<- input$slide_dpi_is

  })

  # Botton download plot
  output$plot_download_is <- downloadHandler(
    filename = function() {
      paste0('stocsy-i.',input$data_input_is)
    },
    content = function(file1) {
      ggplot2::ggsave(file1,width=295, device = input$data_input,height=205, units="mm", dpi = n_dpi)

    }
  )


  observeEvent(input$cutoff_stocsy_is, {

    cor_cutoff <<- input$cutoff_stocsy_is


    for (k in 1:dim(NMRData)[2]) {

      if (k %in% col_select) {

        z <<- which(col_select[] == k)

          if (cor_pearson[drv_pk,z] >= cor_cutoff) {

            rr_is[k] <<- "A"

          }

          else {

            rr_is[k] <<- "B"

          }

        }

      else {

        rr_is[k] <<- "B"  #falta transformar 'rr_is' em variavel reativa

      }

      }

        facts_is$fac_stocsy_is <<- rr_is[]


  })

  # Variables
  peran_multi <<- 0
  ysup_multi <- max(NMRData_plot[1,])
  yinf_multi <- -100



  ysup_multi <- ysup_multi + ysup_multi*0.03
  chkzoom_multi <<- 1
  idb_multi <<- 0


  # Data.frame
  testy_multi <<- data.frame(Chemical_Shift=CS_values_real[1,],Spectrum=NMRData_plot[1,])
  ranges_multi <- reactiveValues(x = c((min(testy_multi$Chemical_Shift)), max(testy_multi$Chemical_Shift)), y = c(yinf_multi,ysup_multi)) ## ESSE É O ORIGINAL
  # ranges_multi_plot <- reactiveValues(x = sort(c((min(testy_multi$Chemical_Shift)), max(testy_multi$Chemical_Shift)), decreasing = TRUE), y = c(yinf_multi,ysup_multi))
  spectrums_multi <- reactiveValues(dat = data.frame(Chemical_Shift=CS_values_real[1,],Spectrum=NMRData_plot[1,]))

  # Plot
    output$plot_multi <- plotly::renderPlotly({

      ggplot2::ggplot(spectrums_multi$dat,ggplot2::aes(Chemical_Shift,Spectrum)) + ggplot2::geom_line(color='blue') + ggplot2::scale_x_reverse() +

        ggplot2::coord_cartesian(xlim = c(ranges_multi$x[2],ranges_multi$x[1]), ylim = ranges_multi$y, expand = FALSE) +

        ggplot2::theme(axis.text.x = ggplot2::element_text(size = 12, color = "#000000"),
                       axis.text.y = ggplot2::element_text(size = 12, color = "#000000"),
                       title = ggplot2::element_text(face = "bold", color = "#000000", size = 17),
                       axis.title = ggplot2::element_text(face = "bold", color = "#000000", size = 15)
                       ) +

        ggplot2::labs(x = "Chemical Shift", y = "Intensity")

    })





  # x2
  observeEvent(input$x2_multi, {

    chkzoom_multi <<- chkzoom_multi*2

    spectrums_multi$dat$Spectrum <- spectrums_multi$dat$Spectrum*2

    })


  # x8
  observeEvent(input$x8_multi, {

    chkzoom_multi <<- chkzoom_multi*8

    spectrums_multi$dat$Spectrum <- spectrums_multi$dat$Spectrum*8

    })


  # /2
  observeEvent(input$q2_multi, {

    chkzoom_multi <<- chkzoom_multi/2

    spectrums_multi$dat$Spectrum <- spectrums_multi$dat$Spectrum/2

    })


  # /8
  observeEvent(input$q8_multi, {

    chkzoom_multi <<- chkzoom_multi/8

    spectrums_multi$dat$Spectrum <- spectrums_multi$dat$Spectrum/8

    })


  # Show all
  observeEvent(input$all_multi, {

    ranges_multi$x <- c(min(CS_values_real[1,]),(max(CS_values_real[1,])))

    freshnum_multi <- which(file_names[] == input$spectrum_list_multi)

    ysup_multi <- max(NMRData_plot[freshnum_multi,])

    yinf_multi <- ysup_multi*-0.03

    ysup_multi <- ysup_multi + ysup_multi*0.03

    ranges_multi$y <- c(yinf_multi,ysup_multi)

    spectrums_multi$dat$Spectrum <- spectrums_multi$dat$Spectrum/chkzoom_multi

    chkzoom_multi <<- 1

    idb_multi <<- 0

    peran_multi <<- 0

    })


  # Move left
  observeEvent(input$s_left_multi, {

    if (!(ranges_multi$x[1] <= min(testy_multi$Chemical_Shift))) {

      ranges_multi$x[1] <- (ranges_multi$x[1] - peran_multi)

      ranges_multi$x[2] <- (ranges_multi$x[2] - peran_multi)

    }

  })


  # Move right
  observeEvent(input$s_right_multi, {

    if (!(ranges_multi$x[2] >= max(testy_multi$Chemical_Shift))) {

      ranges_multi$x[1] <- (ranges_multi$x[1] + peran_multi)

      ranges_multi$x[2] <- (ranges_multi$x[2] + peran_multi)

    }

  })


  # Move full left
  observeEvent(input$s_left_f_multi, {

    if (!(ranges_multi$x[1] <= min(testy_multi$Chemical_Shift))) {

      das_multi <<- (ranges_multi$x[2] - ranges_multi$x[1])

      ranges_multi$x[1] <- min(testy_multi$Chemical_Shift)

      ranges_multi$x[2] <- (min(testy_multi$Chemical_Shift) + das_multi)

    }

  })


  # Move full right
  observeEvent(input$s_right_f_multi, {

    if ((ranges_multi$x[2] <= max(testy_multi$Chemical_Shift))) {

      das_multi <<- abs(ranges_multi$x[1] - ranges_multi$x[2])

      ranges_multi$x[2]  =  max(testy_multi$Chemical_Shift)

      ranges_multi$x[1] <- (ranges_multi$x[2] - das_multi)

    }

  })


  # View samples plot
  observeEvent(input$spectrum_list_multi,{

    freshnum_multi <- which(file_names[] == input$spectrum_list_multi)

    spectrums_multi$dat <<- data.frame(Chemical_Shift=CS_values_real[1,],Spectrum=NMRData_plot[freshnum_multi,])

    if (!idb_multi && chkzoom_multi == 1) {

      ysup_multi <- max (NMRData_plot[freshnum_multi,])

      yinf_multi <- ysup_multi*-0.03

      ysup_multi <- ysup_multi + ysup_multi*0.03

      ranges_multi$y <- c(yinf_multi, ysup_multi)

    }

    else {

        spectrums_multi$dat$Spectrum <- spectrums_multi$dat$Spectrum*chkzoom_multi

    }

  })


  # Second show all (double click)
  observeEvent(input$plot_dblclick_multi, {

    ranges_multi$x <- c(min(CS_values_real[1,]),(max(CS_values_real[1,])))

    freshnum_multi <- which(file_names[] == input$spectrum_list_multi)

    ysup_multi <- max (NMRData_plot[freshnum_multi,])

    yinf_multi <- ysup_multi*-0.03

    ysup_multi <- ysup_multi + ysup_multi*0.03

    ranges_multi$y <- c(yinf_multi,ysup_multi)

    spectrums_multi$dat$Spectrum <- spectrums_multi$dat$Spectrum/chkzoom_multi

    chkzoom_multi <<- 1

    idb_multi <<- 0

    peran_multi <<- 0

    })

# PAREI NA PARTE DE COLOCAR NOVAS SELECÕES ONDE JA TEM AS SELECIONADAS

 # Variables
  NMRData_Mean <- colMeans(NMRData_plot[,])
  col_select <<- c()
  alr_click <<- 0
  sel_ind <<- 0
  exran <<- c()
  exp_click <<- 0
  ysup <- max(NMRData_plot[,])
  col_select_old <- c()


  ############# olhar yinf ###################################
  # yinf <- ysup*-0.03
  yinf <<- -100
  ysup <- ysup + ysup*0.03
  cor_cutoff_p <- 0.9
  cor_cutoff_n <- -0.9
  chkzoom <<- 1
  idb <<- 0
  p_value <- 0.05
  s_stoc <<- 0

  # Data.frame
  testy <<- data.frame(Chemical_Shift=CS_values_real[1,],Spectrum=NMRData_plot[1,])
  CS_selection <<- reactiveValues(vranges = c(-13131313,-131313))
  ranges <- reactiveValues(x = c(min(testy$Chemical_Shift),(max(testy$Chemical_Shift))), y = c(yinf,ysup))
  ranges_sel <- reactiveValues(x = c(min(testy$Chemical_Shift),(max(testy$Chemical_Shift))), y = c(yinf,ysup))
  spectrums <- reactiveValues(dat = data.frame(Chemical_Shift=CS_values_real[1,],Spectrum=NMRData_Mean[]))
  spectrums_sel <- reactiveValues(dat = data.frame(Chemical_Shift=CS_values_real[1,],Spectrum= NMRData_Mean[]))

  # Radio button plot type
  observeEvent(input$radio_s, {
    value <<- (input$radio_s)

    # Plot spectra average
    if (value == 1){

     # Plot left
      output$plot1 <- renderPlot({
        ggplot2::ggplot(spectrums$dat,ggplot2::aes(Chemical_Shift,Spectrum)) + ggplot2::geom_line(color='blue') + ggplot2::scale_x_reverse() +
          ggplot2::coord_cartesian(xlim = c(ranges$x[2],ranges$x[1]), ylim = ranges$y, expand = FALSE) +
          ggplot2::theme(axis.text.x = ggplot2::element_text(size = 12, color = "#000000"),
                        axis.text.y = ggplot2::element_text(size = 12, color = "#000000"),
                        title = ggplot2::element_text(face = "bold", color = "#000000", size = 17),
                        axis.title = ggplot2::element_text(face = "bold", color = "#000000", size = 15)
          ) +
        ggplot2::labs(x = "Chemical Shift", y = "Intensity") +
        ggplot2::geom_vline(xintercept=CS_selection$vranges, color = "red", size = 0.1, alpha=0.01)
  })

  # Plot right
      output$plot2 <- renderPlot({
        ggplot2::ggplot(spectrums_sel$dat,ggplot2::aes(Chemical_Shift,Spectrum)) + ggplot2::geom_line(color='blue') +
          ggplot2::coord_cartesian(xlim = c(ranges_sel$x[2],ranges_sel$x[1]), ylim = ranges_sel$y, expand = FALSE) + ggplot2::scale_x_reverse() +
          ggplot2::theme(axis.text.x = ggplot2::element_text(size = 12, color = "#000000"),
                        axis.text.y = ggplot2::element_text(size = 12, color = "#000000"),
                        title = ggplot2::element_text(face = "bold", color = "#000000", size = 17),
                        axis.title = ggplot2::element_text(face = "bold", color = "#000000", size = 15)
        ) +
        ggplot2::labs(x = "Chemical Shift", y = "Intensity")
      })
    }

    # Plot all samples
    if (value == 2){

      # Plot left
      output$plot1 <- renderPlot({
        p <- ggplot2::ggplot() + ggplot2::scale_x_reverse() +
          ggplot2::coord_cartesian(xlim =  c(ranges$x[2],ranges$x[1]), ylim = ranges$y, expand = FALSE) +
          ggplot2::theme(axis.text.x = ggplot2::element_text(size = 12, color = "#000000"),
                        axis.text.y = ggplot2::element_text(size = 12, color = "#000000"),
                        title = ggplot2::element_text(face = "bold", color = "#000000", size = 17),
                        axis.title = ggplot2::element_text(face = "bold", color = "#000000", size = 15)
          ) +
          ggplot2::labs(x = "Chemical Shift", y = "Intensity") +
          ggplot2::geom_vline(xintercept=CS_selection$vranges, color = "red", size = 0.1, alpha=0.01)

        for (i in 1:length(file_names)) {
          spectrums_multi <- data.frame(Chemical_Shift=CS_values_real[1,],Spectrum=NMRData_plot[i,])
          p <- p + ggplot2::geom_line(data=spectrums_multi, mapping=ggplot2::aes(x=Chemical_Shift,y=Spectrum),color='blue')
        }
        p
      })

  # Plot right
      output$plot2 <- renderPlot({
        k <- ggplot2::ggplot()  + ggplot2::scale_x_reverse() +
          ggplot2::coord_cartesian(xlim =  c(ranges_sel$x[2],ranges_sel$x[1]), ylim = ranges_sel$y, expand = FALSE) +
          ggplot2::theme(axis.text.x = ggplot2::element_text(size = 12, color = "#000000"),
                        axis.text.y = ggplot2::element_text(size = 12, color = "#000000"),
                        title = ggplot2::element_text(face = "bold", color = "#000000", size = 17),
                        axis.title = ggplot2::element_text(face = "bold", color = "#000000", size = 15)
          ) +
          ggplot2::labs(x = "Chemical Shift", y = "Intensity")

        for (i in 1:length(file_names)) {
          spectrums_sel <- data.frame(Chemical_Shift=CS_values_real[1,],Spectrum=NMRData_plot[i,])
          k <- k + ggplot2::geom_line(data=spectrums_sel, mapping=ggplot2::aes(x=Chemical_Shift,y=Spectrum),color='blue')
        }
        k
      })
    }
  })

  # Brush
  observeEvent(input$plot_brush,{
    brush <- input$plot_brush

    if (!is.null(brush)) {
      ranges_sel$x <- c(brush$xmin, brush$xmax)
      ranges_sel$y <- c(brush$ymin, brush$ymax)
      spectrums_sel$dat$Spectrum <- testy$Spectrum*chkzoom
      peran_sel <<- (ranges_sel$x[2] - ranges_sel$x[1])*0.2
    }

    else {
      ranges$x <- c(min(testy$Chemical_Shift),(max(testy$Chemical_Shift)))
    }
  })

  # Brush select signal
  observeEvent(input$sel_brush,{

  })

  # x2
  observeEvent(input$x2_sel1, {
    chkzoom <<- chkzoom*2
    spectrums$dat$Spectrum <- spectrums$dat$Spectrum*2
    })

  # x8
  observeEvent(input$x8_sel1, {
    chkzoom <<- chkzoom*8
    spectrums$dat$Spectrum <- spectrums$dat$Spectrum*8
  })

  # /2
  observeEvent(input$q2_sel1, {
    chkzoom <<- chkzoom/2
    spectrums$dat$Spectrum <- spectrums$dat$Spectrum/2
  })

  # /8
  observeEvent(input$q8_sel1, {
    chkzoom <<- chkzoom/8
    spectrums$dat$Spectrum <- spectrums$dat$Spectrum/8
  })
  
  # Download point selected to save coluns select
  output$downloadpoints_save <- downloadHandler(
    filename = function() {
      paste("Selected_Regions_saved", ".csv", sep = "")
    },
    content = function(file) {
      write.table(reg_selec,file, sep = ",",col.names = FALSE,row.names = FALSE)
    }
  )
  
  

  # Download point selected
  output$downloadpoints <- downloadHandler(
    filename = function() {
        paste("Selected_Regions", ".csv", sep = "")
      },
      content = function(file) {
        col_select <<- col_select[order(col_select)]
        CS_sel_real <<- CS_selection$vranges[order(CS_selection$vranges,decreasing = TRUE)]
        matr_cor <<- matrix(data = NMRData[,col_select],dim(NMRData)[1], length(CS_sel_real))
        colnames(matr_cor) <<- CS_sel_real
        write.table(matr_cor, file,sep = ",",col.names = TRUE,row.names = FALSE)
        write.table(col_select,file, sep = ",",col.names = FALSE,row.names = FALSE)
      }
  )


  # Download bucket selected
  output$downloadareas <- downloadHandler(
    filename = function() {
      paste("Selected_Regions", ".csv", sep = "")},
        content = function(file) {

          if (length(reg_selec) > 2) {
          matrarea <- matr_selec[,rank(reg_selec[,1])]
          regelec <- round(reg_selec[rank(reg_selec[,1]),],2)
          nambu <- paste(as.character(regelec[,1]),as.character(regelec[,2]),sep = "-")
          colnames(matrarea) <- nambu
          write.table(matrarea, file,sep = ",",col.names = TRUE,row.names = FALSE)
          }

          else {
            showModal(modalDialog(
              title = "Warning!!!",
              "Please selected more than one region to download this area",
              easyClose = TRUE,
              footer = modalButton("Close"),
              size = "l"
            ))
          }
        }
  )

  observeEvent(input$rsh_sel1, {
    xsup <- max(CS_values_real[1,])
    xinf <- min(CS_values_real[1,])
    ranges$x <- c(xinf,xsup)
    idb <<- 0
    })


  # Show all
  observeEvent(input$all_h, {
    ysup <- max (NMRData_Mean[])
    yinf <- ysup*-0.03
    ysup <- ysup + ysup*0.03
    ranges$y <- c(yinf,ysup)
    spectrums$dat$Spectrum <- spectrums$dat$Spectrum/chkzoom
    chkzoom <<- 1
    idb <<- 0
  })

  # Button sel
  observeEvent(input$exp_sel1, {
    exp_click <<- exp_click + 1
    exran[exp_click] <<- abs(ranges$x[2] - ranges$x[1])*0.2
    ranges$x <<- c((ranges$x[1] + exran[exp_click] ), (ranges$x[2] - exran[exp_click]))
  })

  # Paint selected region (red)
  observeEvent(input$cont_sel1, {

    if ((ranges$x[1] <= min(testy$Chemical_Shift)) || (ranges$x[2] >= max(testy$Chemical_Shift))) {}

    else {

      if ((exp_click - 1) <= 0) {
        ranges$x <- c(min(testy$Chemical_Shift),(max(testy$Chemical_Shift)))
      }

      else {
      exp_click <<- exp_click - 1
      ranges$x <<- c((ranges$x[1] - exran[exp_click]), (ranges$x[2] + exran[exp_click]))
      }
    }

  })


  # Move left
  observeEvent(input$s_left_sel1, {

    if (!(ranges$x[1] <= min(testy$Chemical_Shift))) {
      ranges$x[1] <<- (ranges$x[1] - exran[exp_click] )
      ranges$x[2] <<- (ranges$x[2] - exran[exp_click] )
    }
  })


  # Move right
  observeEvent(input$s_right_sel1, {

    if (!(ranges$x[2] >= max(testy$Chemical_Shift))) {
      ranges$x[1] <<- (ranges$x[1] + exran[exp_click] )
      ranges$x[2] <<- (ranges$x[2] + exran[exp_click] )
    }
  })


  # Move full left
  observeEvent(input$s_left_f_sel1, {

    if (exp_click > 0 && ranges$x[1] > min(testy$Chemical_Shift)) {
      das <<- abs(ranges$x[1] - ranges$x[2])
      ranges$x[1] <- min(testy$Chemical_Shift)
      ranges$x[2] <- (ranges$x[1] + das)
    }

    else {

    }
  })


  # Move full right
  observeEvent(input$s_right_f_sel1, {

    if (exp_click > 0 && ranges$x[2] < max(testy$Chemical_Shift)) {
      das <<- abs(ranges$x[1] - ranges$x[2])
      ranges$x[2] = max(testy$Chemical_Shift)
      ranges$x[1] <- (ranges$x[2] - das)
    }

    else {

    }
  })

  # Start STOCSY-I
  observeEvent(input$s_stocsy, {


      if (!(sel_ind == 0)) {
        col_select <<- col_select[order(col_select)]
        CS_sel_real <<- CS_selection$vranges[order(CS_selection$vranges,decreasing = TRUE)]
        matr_cor <<- matrix(data = NMRData[,col_select],dim(NMRData)[1], length(col_select))
        cor_pearson <<- cor(matr_cor[,])
        drv_pk <<- which.max(matr_cor[1,])
        rr <<- vector(mode="character")

        norm_test(p_value,matr_cor)
        r_critical(p_value)

        updateSliderInput(session, "cutoff_stocsy_i", min = -1,
                          max = 1, value = c(-0.9,0.9) , step= 0.01)

        for (k in 1:dim(NMRData)[2]) {

          if (k %in% col_select) {
            z <<- which(col_select[] == k)

            if (cor_pearson[drv_pk,z] >= cor_cutoff_p) { #trocar linha com coluna
              rr[k] <<- "A"
            }

            else {
              rr[k] <<- "B"
            }

            if (cor_pearson[drv_pk,z] <= cor_cutoff_n) {
              rr[k] <<- "C"
            }
          }

          else {
              rr[k] <<- "B"
          }
        }
        cor_spearman <<- cor(matr_cor[,], method = "spearman")
        facts$fac_stocsy_i <<- rr[]
        facts_is$fac_stocsy_is <<- rr[]
        facts_rt$fac_stocsy_rt <<- rr[]
        updateTabsetPanel(session, "main_bar", "STOCSY-I")
      }

      else {
        showModal(modalDialog(
          title = "Warning!!!",
          "No region was selected. You must first select the desired region(s) before to start STOSCY analysis!",
          easyClose = TRUE,
          footer = modalButton("Close"),
          size = "l"
        ))
      }

    stop_menssager <- 1
  })
  
  # plot regions selected
  observeEvent(input$region_selected,{
    
    
  })
  

  # Select regions
  observeEvent(input$sel_cor, {
      brush <- input$sel_brush
      if (!is.null(brush)) {

        if (sel_ind == 0) {
          sel_ind <<- 1
          CS_selection$vranges <<- c()
          hlim <- which(abs(CS_values_real[1,]-brush$xmin)==min(abs(CS_values_real[1,]-brush$xmin)))
          llim <- which(abs(CS_values_real[1,]-brush$xmax)==min(abs(CS_values_real[1,]-brush$xmax)))
          col_select <<- c(seq(llim, hlim, 1),col_select_old)
          CS_selection$vranges <<- CS_values_real[1,col_select]
          matr_selec <<- rowSums(matrix(data = NMRData[,llim:hlim],dim(NMRData)[1], length(col_select)))
          reg_selec <<- matrix(data = c(brush$xmin,brush$xmax), 1, 2)
          pos_map <<- matrix(c(1,length(col_select)), 1, 2)
          
        }

        else {
          sel_ind <<- sel_ind + 1
          s_ind <<- 0
          
          if (sel_ind == 2) {

            if (((brush$xmin >= reg_selec[1,1]) && (brush$xmin <= reg_selec[1,2])) || ((brush$xmax >= reg_selec[1,1]) && (brush$xmax <= reg_selec[1,2])) || ((reg_selec[1,1] >= brush$xmin) && (reg_selec[1,1] <= brush$xmax)) || ((reg_selec[1,2] >= brush$xmin) && (reg_selec[1,2] <= brush$xmax))  ) {
            s_ind <<- 1
            sel_ind <<- sel_ind - 1
            }
          }

          else if (sel_ind > 2) {
            ind_gol <- 0
            
            for (i in 1:dim(reg_selec)[1]) {
              if (((brush$xmin >= reg_selec[i,1]) && (brush$xmin <= reg_selec[i,2])) || ((brush$xmax >= reg_selec[i,1]) && (brush$xmax <= reg_selec[i,2])) || ((reg_selec[i,1] >= brush$xmin) && (reg_selec[i,1] <= brush$xmax)) || ((reg_selec[i,2] >= brush$xmin) && (reg_selec[i,2] <= brush$xmax))  ) {
                ind_gol <- 1
              }
            }

            if (ind_gol == 1) {
              s_ind <<- 1
              sel_ind <<- sel_ind - 1
            }
          }
          
          if (s_ind == 0) {
            hlim <- which(abs(CS_values_real[1,]-brush$xmin)==min(abs(CS_values_real[1,]-brush$xmin)))
            llim <- which(abs(CS_values_real[1,]-brush$xmax)==min(abs(CS_values_real[1,]-brush$xmax)))
            col_select_2 <<- seq(llim, hlim, 1)
            col_select <<- c(col_select, col_select_2)
            reg_selec <<- rbind(reg_selec, c(brush$xmin,brush$xmax))
            pos_low <- which(col_select==llim)
            pos_high <- which(col_select==hlim)
            pos_map <<- rbind(pos_map, matrix(c(pos_low,pos_high), 1, 2))
            dyn_brush <- c(brush$xmin,brush$xmax)
            CS_selection$vranges <<- c(CS_selection$vranges, CS_values_real[1,col_select])
            matr_selec <<- cbind(matr_selec,rowSums(matrix(data = NMRData[,llim:hlim],dim(NMRData)[1], length(col_select_2))))
          }

          else {
            showModal(modalDialog(
              title = "Warning!!!",
              "Part of the region you want to load was already loaded. Please, check the loaded regions and select a non superimposed one!!!",
              easyClose = TRUE,
              footer = modalButton("Close"),
              size = "l"
            ))
          }

        }
      }

      else {
        showModal(modalDialog(
          title = "Warning!!!",
          "No region was selected. You must first select the desired region before to click on the button!",
          easyClose = TRUE,
          footer = modalButton("Close"),
          size = "l"
          ))
      }
      
      
# click to delete regions selected
    observeEvent(input$sel_click, {
        if (alr_click == 1) {
         exc_val <- input$sel_click$x

         if (dim(reg_selec)[1] == 1) {
           if ((exc_val >= reg_selec[1,1]) && (exc_val <= reg_selec[1,2])) {
             reg_selec <<- matrix (0, 1, 2)
             col_select <<- c()
             CS_selection$vranges <<- c(-13131313,-131313)
             sel_ind <<- 0
           }
        }

         if (dim(reg_selec)[1] > 1) {
           row_reg <<- 0

           for (i in 1:dim(reg_selec)[1]) {

             if ((exc_val >= reg_selec[i,1]) && (exc_val <= reg_selec[i,2])) {
                row_reg <<- i

             }
           }

           if (row_reg != 0) {
             b_point <- pos_map[row_reg,1]
             e_point <- pos_map[row_reg,2]
             cut_all <- seq(b_point, e_point, 1)

            if (sel_ind == 2) {
               reg_selec <<- matrix(reg_selec[-row_reg,], 1, 2)
             }

             else {
             reg_selec <<- reg_selec[-row_reg,]
             }
             
             col_select <<- col_select[-c(cut_all)]
             CS_selection$vranges <<- CS_values_real[1,col_select]
             if (row_reg == 1) {
             pos_delta <<- as.integer(pos_map[1,2] - pos_map[1,1] + 1)

             if (sel_ind == 2) {
               pos_map_temp <<- matrix(pos_map[-1,], 1, 2)
             }

             else {
               pos_map_temp <<- pos_map[-1,]
             }
             pos_map <<- (pos_map_temp - pos_delta)
             }

             if (row_reg == 2) {
               pos_delta <- (pos_map[2,2] - pos_map[2,1] + 1)
               pos_map_temp <- pos_map[-c(1,2),] - pos_delta
               pos_map <<- rbind(pos_map, pos_map_temp)
             }

             if ((row_reg > 2) && (row_reg < dim(pos_map)[1])) {
               pos_delta <- (pos_map[row_reg,2] - pos_map[row_reg,1] + 1)
               pos_map_temp <- pos_map[-c(1:row_reg),] - pos_delta
               pos_map <<- rbind(pos_map[1:(row_reg-1),], pos_map_temp)
             }

             if (row_reg == dim(pos_map)[1]) {
               pos_map <<- pos_map[-dim(pos_map)[1],]
             }
             sel_ind <<- sel_ind - 1
           }
         alr_click <<- 0
        }
      }
    })

    # Delete region
    observeEvent(input$exc_reg, {
        if (!(sel_ind == 0)) {
        alr_click <<- 1
        }

        else {
          showModal(modalDialog(
            title = "Warning!!!",
            "No region was loaded, so exclusion it is not possible!",
            easyClose = TRUE,
            footer = modalButton("Close"),
            size = "l"
          ))
        }
    })
  })

  observeEvent(input$plot_dblclick, {
    ranges_sel$x <- c(min(testy$Chemical_Shift),(max(testy$Chemical_Shift)))
    ranges$x <- c(min(testy$Chemical_Shift),(max(testy$Chemical_Shift)))
    ysup <- max(testy$Spectrum)
    yinf <- ysup*-0.03
    ysup <- ysup + ysup*0.03
    ranges$y <- c(yinf,ysup)
    ranges_sel$y <- c(yinf,ysup)
    spectrums$dat$Spectrum <- testy$Spectrum
    spectrums_sel$dat$Spectrum <- testy$Spectrum
    chkzoom <<- 1
    idb <<- 0
    peran <<- 0
    })

observeEvent(input$file3, {
  
  buma <<- 0
  
  if(is.null(input$file3))  return(NULL)
  
  up3 <<-input$file3
  if (length(up3$name) < 1) {
    
    showModal(modalDialog(
      title = "Warning!!!",
      "Please select file before to continue!",
      easyClose = TRUE,
      footer = modalButton("Close"),
      size = "l"
    ))
    
    buma <<- 1
    
    
  }
  
  
  else {
    upfile3 <<-list()
    
    # Upload of samples
    
    tmp_e <- new.env()
    load(up3$datapath, tmp_e)
    
    NMRData_plot <<- tmp_e[["nmrdata"]]
    NMRData <<- tmp_e[["nmrdata"]]
    CS_values_real <<- tmp_e[["cs_values_real"]]
    file_names <<- tmp_e[["file_names"]]
    
    if ( min(NMRData) < 0 ) {
      
      NMRData <<- NMRData + (abs(min(NMRData))+1)
      
    }
    #
    
    refreshval()
    
    updateSelectInput(session, "spectrum_list_multi", choices = file_names[])
    
    updateSelectInput(session, "spectrum_list_stocsy_i", choices = file_names[])
    
    updateSelectInput(session, "spectrum_list_stocsy_is", choices = file_names[])
    
    updateSelectInput(session, "spectrum_list_stocsy_rt", choices = file_names[])
    
    updateTabsetPanel(session, "main_bar", "Plot Spectra")
    
  }
  
})



output$imputa3 <- renderUI({
  
  tagList(
    
    (fluidPage(theme = 'zoo.css',
               
               fluidRow(align = "center",
                        
                        fluidRow(div(style="height:30px")),
                        
                        fileInput("file3", "Choose RData Files",
                                  multiple = F,
                                  accept = c(".Rdata")
                        ),
                        
                        fluidRow(div(style="height:30px")),
                        
                        fluidRow( tags$b("IMPORTANT: the RData files must contain only nmrdata (matrix with intensity) cs_values_real (matrix of chemical shift) and file_names (list of sample names) all variables names need to be in low case.")),
                        
                        
                        mainPanel(
                          
                        )
                        
               )
               
    )))
  
})

  fluidPage(theme = 'zoo.css',

    fluidRow(div(style="height:20px"),

    tags$head(tags$style(type="text/css", "
                         #loadmessage {
                         position: fixed;
                         top: 65px;
                         left: 25px;
                         width: 95%;
                         padding: 5px 0px 5px 0px;
                         text-align: center;
                         font-weight: bold;
                         font-size: 100%;
                         color: #ffffff;
                         background-color: #000000;
                         z-index: 1;
                         }
                           ")),

     conditionalPanel(condition="$('html').hasClass('shiny-busy')",
                     tags$div("Loading...",id="loadmessage"))),


     fluidRow(

       column(6,
          sidebarPanel(width = 12,

          fluidRow(align = "center",

            tags$button(id = "x2_sel1",
                        class = "btn action-button btn_lmax",
                        tags$img(src = "bx2.png",
                                 height = "35px", width = "40px")

             ),

            tags$button(id = "x8_sel1",
                        class = "btn action-button btn_r",
                        tags$img(src = "bx8.png",
                                 height = "35px", width = "40px")

            ),

            tags$button(id = "exp_sel1",
                        class = "btn action-button btn_l",
                        tags$img(src = "exp.png",
                                 height = "35px", width = "40px")

            ),

            tags$button(id = "cont_sel1",
                        class = "btn action-button btn_r",
                        tags$img(src = "cont.png",
                                 height = "35px", width = "40px")

            ),

            tags$button(id = "s_left_sel1",
                        class = "btn action-button btn_l",
                        tags$img(src = "s_left.png",
                                 height = "35px", width = "40px")

            ),

            tags$button(id = "s_right_sel1",
                        class = "btn action-button btn_rmax",
                        tags$img(src = "s_right.png",
                                 height = "35px", width = "40px"))



            ),

          fluidRow(div(style="height:5px")),


            fluidRow(align = "center",

               tags$button(id = "q2_sel1",
                           class = "btn action-button btn_lmax",
                           tags$img(src = "bq2.png",
                                    height = "35px", width = "40px")
               ),

               tags$button(id = "q8_sel1",
                           class = "btn action-button btn_r",
                           tags$img(src = "bq8.png",
                                    height = "35px", width = "40px")

               ),

               tags$button(id = "rsh_sel1",
                            class = "btn action-button btn_l",
                            tags$img(src = "rsh.png",
                                     height = "35px", width = "40px")
                ),

               tags$button(id = "exc_reg",
                            class = "btn action-button btn_r",
                            tags$img(src = "exc_reg.png",
                                     height = "35px", width = "40px")
               ),

               tags$button(id = "s_left_f_sel1",
                            class = "btn action-button btn_l",
                            tags$img(src = "s_left_f.png",
                                     height = "35px", width = "40px")

                            ),

               tags$button(id = "s_right_f_sel1",
                           class = "btn action-button btn_rmax",
                           tags$img(src = "s_right_f.png",
                                    height = "35px", width = "40px")
                            )

                   ))),

       column(1,align = "left",



              radioButtons("radio_s", label = h5("Spectrum Type"), selected = 1,
                           choices = list("Average" = 1, "Overlap" = 2))),






    column(5,align = "center",div(style="line-height: 100px; vertical-align: center",
       sidebarPanel(width = 12,


       tags$button(id = "sel_cor",
                   class = "btn action-button btn_t",
                   tags$img(src = "sel_cor.png",
                            height = "35px", width = "40px")),
                   bsTooltip("sel_cor", "Save selected region",
                             "right", options = list(container = "body")),

       tags$button(id = "s_stocsy",
                   class = "btn action-button btn_t",
                   tags$img(src = "s_stocsy_.png",
                            height = "35px", width = "40px")),
                   bsTooltip("s_stocsy", "Start STOCSY-I on raw data",
                            "right", options = list(container = "body")),

        downloadButton("downloadareas",icon("sakod"),
                      class = "btn btn-default shiny-download-link",
                      tags$img(src = "download_buckets.png",
                      height = "35px", width = "40px")),
                      bsTooltip("downloadareas", "Download selected areas",
                                "right", options = list(container = "body")),


        downloadButton("downloadpoints", icon("sakod"),
                      class = "btn shiny-download-link",
                      tags$img(src = "download_points.png",
                      height = "35px", width = "40px")),
                      bsTooltip("downloadpoints", "Download selected points",
                               "right", options = list(container = "body")),
       
       downloadButton("downloadpoints_save", icon("sakod"),
                      class = "btn shiny-download-link",
                      tags$img(src = "save_selected.png",
                               height = "35px", width = "40px")),
       bsTooltip("downloadpoints", "Download selected points",
                 "right", options = list(container = "body"))
       
       


        )

              ))),

    fluidRow(div(style="height:15px")),


      fluidRow(

        column(6, align="center",
          sidebarPanel(width = 12,

          fluidRow(p(strong("Select a region to be expanded at the right plot."))),



          plotOutput("plot1", height = "450px",click = "sel_click", dblclick = "plot_dblclick",
                     brush = brushOpts(id = "plot_brush",delay = 5000, fill = "#ccc", direction = "xy", resetOnNew = TRUE))
        )),

        column(6, align="center",
          sidebarPanel(width = 12,

           fluidRow(p(strong("Select each region of interest and click on top left button to save it, then click on START."))),

           plotOutput("plot2", height = "450px", click = "cor_click", dblclick = "cor_dblclick",
                        brush = brushOpts(id = "sel_brush",delay = 5000, fill = "#ccc", direction = "x", resetOnNew = TRUE))



        )
      ))

)

 fluidPage(theme = 'zoo.css',
    fluidRow(align="center",
      column(3,align = "center",
             sidebarPanel(width = 12,
        radioButtons("radio", label = h5("Correlation Type"), selected = 1,
                     choices = list("Pearson" = 1, "Spearman" = 2)
        )
        )),
      column(9,align = "center",
             sidebarPanel(width = 12,
      selectInput("spectrum_list_stocsy_i","Which spectrum do you want to see?",file_names[], selectize = FALSE),
      p(strong("To perform STOCSY analysis, double click on the desired driver peak in the spectrum below."))
      )
    )
      ),

    fluidRow(

    column(3, align="center",

    sidebarPanel(width = 12,

      fluidRow(align = "center",



        fluidRow(


          sliderInput("cutoff_stocsy_i", label = h5("Correlation Cutoff"), min = -1, width = '250px',
                      max = 1, value = c(-0.9,0.9) , step= 0.01),
                      bsTooltip("cutoff_stocsy_i", "Set the minimum correlation coefficients",
                                "right", options = list(container = "body"))
        ),

        fluidRow(div(style="width:100px;", textInput("pv", "p-value", "0.05")
                    )),

        fluidRow(div(style="width:250px;", verbatimTextOutput("r_critical"),
                                    bsTooltip("r_critical", "R critical is calculate based on t-Student table, for the chosen p-value.",
                                              "right", options = list(container = "body")))),
        fluidRow(div(style="height:5px")),

        fluidRow(

          tags$button(id = "x2_stocsy_i",
                      class = "btn action-button",
                      tags$img(src = "bx2.png",
                               height = "35px", width = "40px")
          ),

          tags$button(id = "x8_stocsy_i",
                      class = "btn action-button",
                      tags$img(src = "bx8.png",
                               height = "35px", width = "40px")
                           )
          ),

           fluidRow(div(style="height:5px")),

             fluidRow(

                tags$button(id = "q2_stocsy_i",
                             class = "btn action-button",
                             tags$img(src = "bq2.png",
                                      height = "35px", width = "40px")
                ),

                tags$button(id = "q8_stocsy_i",
                            class = "btn action-button",
                            tags$img(src = "bq8.png",
                                     height = "35px", width = "40px")
                           )
                ),

            br(),

            fluidRow(

              tags$button(id = "s_left_stocsy_i",
                          class = "btn action-button",
                          tags$img(src = "s_left.png",
                                   height = "35px", width = "40px")
                           ),

                           tags$button(
                             id = "s_right_stocsy_i",
                             class = "btn action-button",
                             tags$img(src = "s_right.png",
                                      height = "35px", width = "40px")
                           )
              ),

            fluidRow(div(style="height:5px")),

            fluidRow(

              tags$button(id = "s_left_f_stocsy_i",
                          class = "btn action-button",
                          tags$img(src = "s_left_f.png",
                                   height = "35px", width = "40px")
              ),

              tags$button(id = "s_right_f_stocsy_i",
                          class = "btn action-button",
                          tags$img(src = "s_right_f.png",
                                   height = "35px", width = "40px")
               )
              ),

             br(),

             fluidRow(

               tags$button(id = "all_stocsy_i",
                           class = "btn action-button",
                           tags$img(src = "all.png",
                           height = "35px", width = "40px")),
                           bsTooltip("all_stocsy_i", "Show all spectrum",
                                     "right", options = list(container = "body")),

    ),

             br(),




          fluidRow(

            selectInput("data_input",label="File extension", width = '100px',
                        choices=c("png","tiff","jpeg","pdf")),
            bsTooltip("data_input", "Select type file to download plot",
                      "right", options = list(container = "body")),
            # ),

            # column(4, align="center",
            #        fluidRow(div(style="height:5px")),

            sliderInput("slide_dpi", label= 'DPI' ,min = 100, width = '250px',
                        max = 1000, value = 200 , step= 10),
            bsTooltip("slide_dpi", "Select dpi to download plot",
                      "right", options = list(container = "body")),
            # ),

            # column(4, align="center",

            downloadButton("plot_download","Download Plot", width = '100px',
                           class = "btn shiny-download-link")
            ))



        )),


        column(9, align="center",
               sidebarPanel(width = 12,

          plotOutput("plot_stocsy_i", width = "100%", height = "500px", click = "click_stocsy_i", dblclick = "dblclick_stocsy_i",
                     brush = brushOpts(id = "plot_brush_stocsy_i",delay = 5000,
                     fill = "#ccc", direction = "xy", resetOnNew = TRUE)

           ),

        ))
    )




  )

fluidPage(title="iSTATS",
  fluidRow(
    column(12, align="center",
           navbarPage(id = "main_bar",title = div(style = "vertical-align: top",img(src="iSTATS_logo.png", heigth = "80px",
                                                                                    width = "80px")), selected = "Home", inverse = T,
                      navbarMenu("Data",

                                  tabPanel("Import Bruker file - convbin2asc",
                                           uiOutput('imputa')),

                                  tabPanel("Import CSV file",
                                           uiOutput('imputa2')),

                                  tabPanel("Import Rdata file",
                                           uiOutput('imputa3')),

                                  tabPanel("Example Data",
                                          source('example_data_ui.R', local = T)[1])


                      ),

                      navbarMenu("Plot",

                                 tabPanel("Plot Spectra",
                                          source('plot_interativo_ui.R', local = T)[1])
                      ),

                      navbarMenu("Select",

                                 tabPanel("Select Signals",
                                          source('select_signals_ui.R', local = T)[1]
                                 ),

                                 tabPanel("Normalize Selection",
                                          source('Pretreatment_ui.R', local = T)[1]
                                 )
                      ),

                      navbarMenu("STOCSY",

                                 tabPanel("STOCSY-I",
                                          source('stocsy_i_ui.R', local = T)[1]
                                 ),

                                 tabPanel("STOCSY-IS",
                                          source('stocsy_is_ui.R', local = T)[1]
                                 ),

                                 tabPanel("STOCSY-RT",
                                          source('stocsy_rt_ui.R', local = T)[1]

                                 )
                      ),

                      navbarMenu("More",

                                 tabPanel("Home",
                                          source('home_ui.R', local = T)[1]),

                                 tabPanel("Contact",
                                          source('about_ui.R', local = TRUE)[1]
                                 )
                      )
           ),

           conditionalPanel(condition="$('html').hasClass('shiny-busy')",
                            tags$div("Loading...",id="loadmessage")
           )
    )
  )
)

  fluidPage(theme = 'zoo.css',

    fluidRow(

        column(3,align = "center",
               sidebarPanel(width = 12,

           radioButtons("radio_is", label = h5("Correlation Type"),selected = 1,
                                       choices = list("Pearson" = 1, "Spearman" = 2))
          )),

        column(9,align = "center",
               sidebarPanel(width = 12,

         selectInput("spectrum_list_stocsy_is","Which spectrum do you want to see?",file_names[], selectize = FALSE),

         p(strong("To perform STOCSY scaling, double click on the desired driver peak and then click on the button",em("START STOCSY-is"),"at the left menu.")))

        )),

      fluidRow(align = "center",

         column(3, align="center",
          sidebarPanel(width = 12,

           fluidRow(

             sliderInput("cutoff_stocsy_is", label = h5("Correlation Cutoff"), min = 0,width = '250px',
                         max = 1, value = 0.9 , step= 0.01)
            ),

           fluidRow(

             tags$button(id = "stocsy_s",
                         class = "btn action-button",
                         tags$img(src = "s_stocsy_is.png",
                                  height = "35px", width = "40px")
                            )
            ),

           br(),

           fluidRow(

             tags$button(id = "x2_stocsy_is",
                         class = "btn action-button",
                         tags$img(src = "bx2.png",
                                  height = "35px", width = "40px")

             ),

             tags$button(id = "x8_stocsy_is",
                         class = "btn action-button",
                         tags$img(src = "bx8.png",
                                  height = "35px", width = "40px")
              )
             ),

           fluidRow(div(style="height:5px")),

             fluidRow(

               tags$button(id = "q2_stocsy_is",
                           class = "btn action-button",
                           tags$img(src = "bq2.png",
                                    height = "35px", width = "40px")
                ),

               tags$button(id = "q8_stocsy_is",
                           class = "btn action-button",
                           tags$img(src = "bq8.png",
                                    height = "35px", width = "40px")
                            )
               ),

           br(),


           fluidRow(

             tags$button(id = "s_left_stocsy_is",
                         class = "btn action-button",
                         tags$img(src = "s_left.png",
                                  height = "35px", width = "40px")

              ),

             tags$button(id = "s_right_stocsy_is",
                         class = "btn action-button",
                         tags$img(src = "s_right.png",
                                  height = "35px", width = "40px")
              )
             ),

           fluidRow(div(style="height:5px")),

             fluidRow(

               tags$button(id = "s_left_f_stocsy_is",
                           class = "btn action-button",
                           tags$img(src = "s_left_f.png",
                                    height = "35px", width = "40px")

                ),

               tags$button(id = "s_right_f_stocsy_is",
                           class = "btn action-button",
                           tags$img(src = "s_right_f.png",
                                    height = "35px", width = "40px"))),


           br(),


           fluidRow(

             tags$button(id = "all_stocsy_is",
                         class = "btn action-button",
                         tags$img(src = "all.png",
                                  height = "35px", width = "40px")

              ),

             br()

             ),
           br(),

           fluidRow(

             selectInput("data_input_is",label="File extension", width = '100px',
                         choices=c("png","tiff","jpeg","pdf")),
             bsTooltip("data_input_is", "Select type file to download plot",
                       "right", options = list(container = "body")),
             # ),

             # column(4, align="center",
             #        fluidRow(div(style="height:5px")),

             sliderInput("slide_dpi_is", label= 'DPI' ,min = 100, width = '250px',
                         max = 1000, value = 200 , step= 10),
             bsTooltip("slide_dpi", "Select dpi to download plot",
                       "right", options = list(container = "body")),
             # ),

             # column(4, align="center",

             downloadButton("plot_download_is","Download Plot", width = '100px',
                            class = "btn shiny-download-link")
           )
           )),



         column(9, align="center",

                sidebarPanel(width = 12,


           plotOutput("plot_stocsy_is", width = "100%", height = "500px", click = "click_stocsy_is", dblclick = "dblclick_stocsy_is",
                      brush = brushOpts(id = "plot_brush_stocsy_is",delay = 5000, fill = "#ccc", direction = "xy", resetOnNew = TRUE)

            )


           )
      ))
  )

  (fluidPage(theme = 'zoo.css',

    fluidRow(align = "center",

      fluidRow(div(style="height:20px")),

      fluidRow( tags$b("Click on the below button to load an example data:")),

      fluidRow(div(style="height:20px")),

        tags$button(id = "example_but",
                    class = "btn action-button btn_lmax",
                    tags$img(src = "example.png",
                             height = "50px", width = "50px")

                    )


           )))

  (fluidPage(theme = 'zoo.css',


    fluidRow(div(style="height:50px")),

     tags$img(src = "istats1.gif",
              height = "450px", width = "524px"))

    # tags$img(src = "logo_stocsy.gif",
    #          height = "200px", width = "450px"))
    )

## Module Pretreatment ###############################

# Variables
NMRData_Mean <- colMeans(NMRData[,])
ysup <- max(NMRData[,])
yinf <- ysup*-0.03
ysup <- ysup + ysup*0.03
p_value <- 0.05


# Data.frame
testy_norm <<- data.frame(Chemical_Shift=CS_values_real[1,],Spectrum=NMRData[1,])
CS_norm <<- reactiveValues(vranges = c(-13131313,-131313))
ranges <- reactiveValues(x = c(min(testy_norm$Chemical_Shift),(max(testy_norm$Chemical_Shift))), y = c(yinf,ysup))
ranges_sel <- reactiveValues(x = c(min(testy_norm$Chemical_Shift),(max(testy_norm$Chemical_Shift))), y = c(yinf,ysup))
spectrums <- reactiveValues(dat = data.frame(Chemical_Shift=CS_values_real[1,],Spectrum=NMRData[1,]))
spectrums_sel <- reactiveValues(dat = data.frame(Chemical_Shift=CS_values_real[1,],Spectrum=NMRData[1,]))
rr_n <<- reactiveValues(csranges = c(-13131313,-131313))



# Show Normalize section
observeEvent(input$pretreatment, {
  updateTabsetPanel(session, "main_bar", "Normalize Selection")
  removeModal()
  .mean_centering()
})


# Plot Normalization

# Plot spectra average
output$plot_norm <- renderPlot({
  ggplot2::ggplot(spectrums$dat,ggplot2::aes(Chemical_Shift,Spectrum)) + ggplot2::geom_line(color='blue') + ggplot2::scale_x_reverse() +
    ggplot2::coord_cartesian(xlim = c(ranges$x[2],ranges$x[1]), ylim = ranges$y, expand = FALSE) +
    ggplot2::theme(axis.text.x = ggplot2::element_text(size = 12, color = "#000000"),
                    axis.text.y = ggplot2::element_text(size = 12, color = "#000000"),
                    title = ggplot2::element_text(face = "bold", color = "#000000", size = 17),
                    axis.title = ggplot2::element_text(face = "bold", color = "#000000", size = 15)
    ) +
    ggplot2::labs(x = "Chemical Shift", y = "Intensity") +
    ggplot2::geom_vline(xintercept=rr_nn$csranges, color = "green", size = 0.1, alpha=0.3) +
    ggplot2::geom_vline(xintercept=rr_n$csranges, color = "red", size = 0.1, alpha=0.3)
})



# Brush
observeEvent(input$plot_brush_norm,{
  brush <- input$plot_brush_norm

  if (!is.null(brush)) {
    ranges$x <- c(brush$xmin, brush$xmax)
    ranges$y <- c(brush$ymin, brush$ymax)
    spectrums$dat$Spectrum <- testy$Spectrum*chkzoom
    peran <<- (ranges$x[2] - ranges$x[1])*0.2
  }

  else {
    ranges$x <- c(min(testy$Chemical_Shift),(max(testy$Chemical_Shift)))
  }
})


# Mean centering
observeEvent(input$mean_norm,{
  # s_stoc <<- 0


  .mean_centering()

  choose_norm <<- 7

})


# Scaling
observeEvent(input$scaling_norm,{
  if (!(sel_ind == 0)) {

  rr_n$csranges <<- c()
  col_sel_norm <<- c()

  .autoscaling()

  f <- 0
  output$norm_cond <- renderText(paste("After normalize: ", dif,"%"))

  for (j in 1:length(norm_var)) {

    if (norm_var[j] == "NO") {
      f <- f + 1
      col_sel_norm[f] <<- col_select[j]
    }
    else{

    }
  }
  rr_n$csranges <- CS_values_real[1,col_sel_norm]
  choose_norm <<- 6
  }

  else{
    showModal(modalDialog(
      title = "Warning!!!",
      "No region was selected. You must first select the desired region(s) before to start Normalize section!",
      easyClose = TRUE,
      footer = modalButton("Close"),
      size = "l"
    ))
  }

})


# Pareto
observeEvent(input$pareto_norm,{

  if (!(sel_ind == 0)) {

  rr_n$csranges <<- c()
  .pareto()
  col_sel_norm <<- c()
  f <- 0


  output$norm_cond <- renderText(paste("Affter normalize: ", dif,"%"))

  for (j in 1:length(norm_var)) {

    if (norm_var[j] == "NO") {
      f <- f + 1
      col_sel_norm[f] <<- col_select[j]
    }
    else{

    }
  }
  rr_n$csranges <- CS_values_real[1,col_sel_norm]
  choose_norm <<- 5
  }
  else{
    showModal(modalDialog(
      title = "Warning!!!",
      "No region was selected. You must first select the desired region(s) before to start Normalize section!",
      easyClose = TRUE,
      footer = modalButton("Close"),
      size = "l"
    ))
  }

})

# Square Root
observeEvent(input$sqr_norm,{
  if (!(sel_ind == 0)) {

  rr_n$csranges <<- c()
  .sqr_norm()
  col_sel_norm <<- c()
  f <- 0

  output$norm_cond <- renderText(paste("Affter normalize: ", dif,"%"))

  for (j in 1:length(norm_var)) {

    if (norm_var[j] == "NO") {
      f <- f + 1
      col_sel_norm[f] <<- col_select[j]
    }
    else{

    }
  }

  rr_n$csranges <- CS_values_real[1,col_sel_norm]
  choose_norm <<- 4
  }

  else{
    showModal(modalDialog(
      title = "Warning!!!",
      "No region was selected. You must first select the desired region(s) before to start Normalize section!",
      easyClose = TRUE,
      footer = modalButton("Close"),
      size = "l"
    ))
  }

})


# Inverse Square Root
observeEvent(input$i_sqr_norm,{
  if (!(sel_ind == 0)) {

  rr_n$csranges <<- c()
  .isqr_norm()
  col_sel_norm <<- c()
  f <- 0

  output$norm_cond <- renderText(paste("Affter normalize: ", dif,"%"))

  for (j in 1:length(norm_var)) {

    if (norm_var[j] == "NO") {
      f <- f + 1
      col_sel_norm[f] <<- col_select[j]
    }
    else{

    }
  }

  rr_n$csranges <- CS_values_real[1,col_sel_norm]
  choose_norm <<- 3
  }

  else{
    showModal(modalDialog(
      title = "Warning!!!",
      "No region was selected. You must first select the desired region(s) before to start Normalize section!",
      easyClose = TRUE,
      footer = modalButton("Close"),
      size = "l"
    ))
  }

})


# Log
observeEvent(input$log_norm,{

  if (!(sel_ind == 0)) {

  rr_n$csranges <<- c()
  .log_norm()
  col_sel_norm <<- c()
  f <- 0

  output$norm_cond <- renderText(paste("Affter normalize: ", dif,"%"))

  for (j in 1:length(norm_var)) {

    if (norm_var[j] == "NO") {
      f <- f + 1
      col_sel_norm[f] <<- col_select[j]
    }
    else{

    }
  }

  rr_n$csranges <- CS_values_real[1,col_sel_norm]
  choose_norm <<- 2
  }

  else{
    showModal(modalDialog(
      title = "Warning!!!",
      "No region was selected. You must first select the desired region(s) before to start Normalize section!",
      easyClose = TRUE,
      footer = modalButton("Close"),
      size = "l"
    ))
  }

})



# Start STOCSY-I
observeEvent(input$s_stocsy_i_norm, {
  if (choose_norm == 1) {
    .s_stocsy(matr_cor)
  }

  if (choose_norm == 2) {
    .s_stocsy(NMR_log)
  }
  if (choose_norm == 3) {
    .s_stocsy(NMR_i_sqr)
  }
  if (choose_norm == 4) {
    .s_stocsy(NMR_sqr)
  }
  if (choose_norm == 5) {
    .s_stocsy(NMR_Pareto)
  }
  if (choose_norm == 6) {
    .s_stocsy(NMR_ASC)
  }
  if (choose_norm == 7) {
    .s_stocsy(NMR_MC)
  }

})


# R critical by P-value
observeEvent(input$pv_n, {
  p_value_n <- as.numeric(input$pv_n)
  p_value <- p_value_n
  r_critical(p_value_n)
  output$r_critical <- renderText(paste("R critical = +/-",abs(R_CRITICAL[1])))
})





# Download point selected
output$downloadpoints2 <- downloadHandler(
  filename = function() {
    paste("Selected_Regions", ".csv", sep = "")
  },
  content = function(file) {
    if (choose_norm == 1) {
      col_select <<- col_select[order(col_select)]
      CS_sel_real <<- CS_selection$vranges[order(CS_selection$vranges,decreasing = TRUE)]
      matr_cor <<- matrix(data = NMRData[,col_select],dim(NMRData)[1], length(CS_sel_real))
      colnames(matr_cor) <<- CS_sel_real
      write.table(matr_cor, file,sep = ",",col.names = TRUE,row.names = FALSE)
    }
    if (choose_norm == 2) {
      col_select <<- col_select[order(col_select)]
      CS_sel_real <<- CS_selection$vranges[order(CS_selection$vranges,decreasing = TRUE)]
      colnames(NMR_log) <<- CS_sel_real
      write.table(NMR_log, file,sep = ",",col.names = TRUE,row.names = FALSE)
    }
    if (choose_norm == 3) {
      col_select <<- col_select[order(col_select)]
      CS_sel_real <<- CS_selection$vranges[order(CS_selection$vranges,decreasing = TRUE)]
      colnames(NMR_i_sqr) <<- CS_sel_real
      write.table(NMR_i_sqr, file,sep = ",",col.names = TRUE,row.names = FALSE)
    }
    if (choose_norm == 4) {
      col_select <<- col_select[order(col_select)]
      CS_sel_real <<- CS_selection$vranges[order(CS_selection$vranges,decreasing = TRUE)]
      colnames(NMR_sqr) <<- CS_sel_real
      write.table(NMR_sqr, file,sep = ",",col.names = TRUE,row.names = FALSE)
    }
    if (choose_norm == 5) {
      col_select <<- col_select[order(col_select)]
      CS_sel_real <<- CS_selection$vranges[order(CS_selection$vranges,decreasing = TRUE)]
      colnames(NMR_Pareto) <<- CS_sel_real
      write.table(NMR_Pareto, file,sep = ",",col.names = TRUE,row.names = FALSE)
    }
    if (choose_norm == 6) {
      col_select <<- col_select[order(col_select)]
      CS_sel_real <<- CS_selection$vranges[order(CS_selection$vranges,decreasing = TRUE)]
      colnames(NMR_ASC) <<- CS_sel_real
      write.table(NMR_ASC, file,sep = ",",col.names = TRUE,row.names = FALSE)
    }
    if (choose_norm == 7) {
      col_select <<- col_select[order(col_select)]
      CS_sel_real <<- CS_selection$vranges[order(CS_selection$vranges,decreasing = TRUE)]
      colnames(NMR_MC) <<- CS_sel_real
      write.table(NMR_MC, file,sep = ",",col.names = TRUE,row.names = FALSE)
    }
  }
)

# Download bucket selected
output$downloadareas2 <- downloadHandler(
  filename = function() {
    paste("Normalize_Regions", ".csv", sep = "")},
  content = function(file) {

    if (choose_norm == 1) {

      if (length(reg_selec) > 2) {
        matrarea <- matr_selec[,rank(reg_selec[,1])]
        regelec <- round(reg_selec[rank(reg_selec[,1]),],2)
        nambu <- paste(as.character(regelec[,1]),as.character(regelec[,2]),sep = "-")
        colnames(matrarea) <- nambu
        write.table(matrarea, file,sep = ",",col.names = TRUE,row.names = FALSE)
      }

      else {
        showModal(modalDialog(
          title = "Warning!!!",
          "Please selected more than one region to download this area",
          easyClose = TRUE,
          footer = modalButton("Close"),
          size = "l"
        ))
      }
    }

    if (choose_norm == 2) {

      if (length(reg_selec) > 2) {
        matrarea <- matr_selec[,rank(reg_selec[,1])]
        regelec <- round(reg_selec[rank(reg_selec[,1]),],2)
        nambu <- paste(as.character(regelec[,1]),as.character(regelec[,2]),sep = "-")
        colnames(matrarea) <- nambu
        write.table(matrarea, file,sep = ",",col.names = TRUE,row.names = FALSE)
      }

      else {
        showModal(modalDialog(
          title = "Warning!!!",
          "Please selected more than one region to download this area",
          easyClose = TRUE,
          footer = modalButton("Close"),
          size = "l"
        ))
      }
    }

    if (choose_norm == 3) {

      if (length(reg_selec) > 2) {
        matrarea <- matr_selec[,rank(reg_selec[,1])]
        regelec <- round(reg_selec[rank(reg_selec[,1]),],2)
        nambu <- paste(as.character(regelec[,1]),as.character(regelec[,2]),sep = "-")
        colnames(matrarea) <- nambu
        write.table(matrarea, file,sep = ",",col.names = TRUE,row.names = FALSE)
      }

      else {
        showModal(modalDialog(
          title = "Warning!!!",
          "Please selected more than one region to download this area",
          easyClose = TRUE,
          footer = modalButton("Close"),
          size = "l"
        ))
      }
    }

    if (choose_norm == 4) {

      if (length(reg_selec) > 2) {
        matrarea <- matr_selec[,rank(reg_selec[,1])]
        regelec <- round(reg_selec[rank(reg_selec[,1]),],2)
        nambu <- paste(as.character(regelec[,1]),as.character(regelec[,2]),sep = "-")
        colnames(matrarea) <- nambu
        write.table(matrarea, file,sep = ",",col.names = TRUE,row.names = FALSE)
      }

      else {
        showModal(modalDialog(
          title = "Warning!!!",
          "Please selected more than one region to download this area",
          easyClose = TRUE,
          footer = modalButton("Close"),
          size = "l"
        ))
      }
    }

    if (choose_norm == 5) {

      if (length(reg_selec) > 2) {
        matrarea <- matr_selec[,rank(reg_selec[,1])]
        regelec <- round(reg_selec[rank(reg_selec[,1]),],2)
        nambu <- paste(as.character(regelec[,1]),as.character(regelec[,2]),sep = "-")
        colnames(matrarea) <- nambu
        write.table(matrarea, file,sep = ",",col.names = TRUE,row.names = FALSE)
      }

      else {
        showModal(modalDialog(
          title = "Warning!!!",
          "Please selected more than one region to download this area",
          easyClose = TRUE,
          footer = modalButton("Close"),
          size = "l"
        ))
      }
    }

    if (choose_norm == 6) {

      if (length(reg_selec) > 2) {
        matrarea <- matr_selec[,rank(reg_selec[,1])]
        regelec <- round(reg_selec[rank(reg_selec[,1]),],2)
        nambu <- paste(as.character(regelec[,1]),as.character(regelec[,2]),sep = "-")
        colnames(matrarea) <- nambu
        write.table(matrarea, file,sep = ",",col.names = TRUE,row.names = FALSE)
      }

      else {
        showModal(modalDialog(
          title = "Warning!!!",
          "Please selected more than one region to download this area",
          easyClose = TRUE,
          footer = modalButton("Close"),
          size = "l"
        ))
      }
    }

    if (choose_norm == 7) {

      if (length(reg_selec) > 2) {
        matrarea <- matr_selec[,rank(reg_selec[,1])]
        regelec <- round(reg_selec[rank(reg_selec[,1]),],2)
        nambu <- paste(as.character(regelec[,1]),as.character(regelec[,2]),sep = "-")
        colnames(matrarea) <- nambu
        write.table(matrarea, file,sep = ",",col.names = TRUE,row.names = FALSE)
      }

      else {
        showModal(modalDialog(
          title = "Warning!!!",
          "Please selected more than one region to download this area",
          easyClose = TRUE,
          footer = modalButton("Close"),
          size = "l"
        ))
      }
    }
  }
)

# Plot_PDF I-STOCSY
observeEvent(input$norm_print_PDF, {
  ggplot2::ggsave("normal_regions.pdf",path = choose.dir(),width=195, height=105, units="mm", dpi = 300)
})
